# File svdfit/svdvec.cl
# December 17, 2008
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# SVDVEC -- Decompose a set of spectra into their eigenvectors

procedure svdvec (infile, outfile)

string	infile=""	{prompt="Two-dimensional file of stacked spectra"}

string	outfile=""	{prompt="Two-dimensional file of stacked eigenvectors"}
int	pass=0		{prompt="Number of the current pass"}

bool	verbose=no	{prompt="Print what's happening (y or n)"}
bool	debug=no	{prompt="Debugging mode (y or n)"}

begin

bool	vb, delf
string	arg, ofile
file	ifile

	vb = verbose
	ifile = infile
	ofile = outfile
	if (ifile != "") {
	    if (vb) {
		if (pass > 0)
		    arg = "-v -p " // pass // " " // ifile
		else
		    arg = "-v " // ifile
		}
	    else {
		if (pass > 0)
		    arg = "-p " // pass // " " // ifile
		else
		    arg = ifile
		}
	    if (ofile == "") {
		fileroot (ifile)
		arg = arg // " " // fileroot.rootname // "_svd"
		arg = arg // "." // fileroot.extname
		}
	    else {
		arg = arg // " " // ofile
		}
	    if (vb) {
		print ("svdvec ", arg)
		}
	    esvdvec (arg)
	    }
	else {
	    print ("SVDVEC:  Input file must be specified")
	    }
end

# Oct 10 2000	New task renamed from svdsky

# Apr  3 2001	Rewrite to prompt only once if infile is not set

# Dec 17 2008	Set verbosity and pass number correctly
