c*** File fitslib/fitsinv.f
c*** March 28, 1991
c*** By Doug Mink

c--- Invert FITS image region

	Subroutine FITSINV (HEADER,IMAGE,IX1,IX2,IY1,IY2)

	Character*(*) HEADER
c				Header string
	Integer*4 IMAGE(*)
c				FITS image (modified)
	Integer*4 IX1,IY1
c				One corner of region to be marked
	Integer*4 IX2,IY2
c				Other corner of region to be marked


	Integer*4 BITPIX,NAXIS,NAXIS1,NAXIS2,IR1,IR2,IC1,IC2,OFFSET
	Integer*4 NBPIX,NBR0,NC,IR
	Character*80 STRING
	Include 'header.cmb'

	Call ESET

c  Get dimensions of image

	Call HGETI4 (HEADER,'BITPIX',BITPIX)
	If (BITPIX .gt. 8) Then
	    Write(*,*) 'FITSINV:  Cannot invert ',BITPIX,'-bit pixels'
	    Return
	    Endif
	Call HGETI4 (HEADER,'NAXIS',NAXIS)
	Call HGETI4 (HEADER,'NAXIS1',NAXIS1)
	NBPIX = BITPIX / 8
	NBR0 = NAXIS1 * NBPIX
	If (NAXIS .gt. 1) Then
	    Call HGETI4 (HEADER,'NAXIS2',NAXIS2)
	    NBR0 = NBR0 * NAXIS2
	    Endif

c  Set column limits and number of columns to invert

	If (IX2 .ge. IX1) Then
	    IC1 = IX1
	    IC2 = IX2
	Else
	    IC2 = IX1
	    IC1 = IX2
	Endif
	If (IC1 .lt. 1) IC1 = 1
	If (IC2 .gt. NAXIS1) IC2 = NAXIS1
	NC = IC2 - IC1 + 1

c  Set row limits to invert

	If (IY2 .ge. IY1) Then
	    IR1 = IY1
	    IR2 = IY2
	Else
	    IR2 = IY1
	    IR1 = IY2
	Endif
	If (IR1 .lt. 1) IR1 = 1
	If (IR2 .gt. NAXIS2) IR2 = NAXIS2

	If (VERBOSE) Then
	    Write(STRING,*) 'Inverting rows',IR1,' -',IR2,' columns',IC1,' -',IC2
	    Call PSTRING (STRING)
	    Write(STRING,*) 'Image is',NAXIS1,' x',NAXIS2
	    Call PSTRING (STRING)
	    Endif

c  Offset is zero-based

	OFFSET = (IR1 - 1) * NAXIS1 + (IC1 - 1)

c  Set bits

	Do 100 IR = IR1, IR2
	    If (BITPIX .eq. 8) Then
		Call SVINV1 (IMAGE,OFFSET,NC)
	    Elseif (BITPIX .eq. 16) Then
		Call SVINV2 (IMAGE,OFFSET,NC)
	    Elseif (BITPIX .eq. 32) Then
		Call SVINV4 (IMAGE,OFFSET,NC)
	    Endif
100	    OFFSET = OFFSET + NAXIS1

	Return
	End
