c*** File fitslib/fitsrhead.f
c*** August 20, 1998
c*** By Doug Mink, Center for Astrophysics

	Subroutine FITSRHEAD (INPATH, HEADER, NBHEAD)

	Character*(*) INPATH
c				Pathname for FITS tables file to read
	Character*(*) HEADER
c				Header for FITS tables file to read
	Integer*4 NBHEAD
c				Number of bytes of header information
c				This includes the first, simple header block

	Logical EXTEND, NEWHDU
	Integer*4 LIN,NBYTES,IH0,IH1,IEND,NBENTRY,NAXIS
	Integer*4 NAX,NAX1,NAX2,NAX3,NAX4,NBPIX,IBPIX,NBSKIP,IPOS
	Integer*4 NTRY,NBR,IER,NHDU,NBLOCK,LEXT,JEND,LPHEAD,IHDU
	Character*2880 FITSBUF
	Character*5760 PHEADER
	Character*32 EXTNAME
	Integer*4 IFD
c				File descriptor for FITS tables file
	Logical NUMEXT
c			True if image extension is number instead of name

	Include 'header.cmb'
	Include 'fitshead.cmb'

	Data FITSHDU / -1 /

	PHEADER(1:1) = Char (0)

c  Open input file
	NBHEAD = 0
	Call ZSTRING (HEADER)
	NBSKIP = 0
	NTRY = 0
	NHDU = 0
	IHDU = Index (INPATH,',')
	If (IHDU .gt. 0) Then
	    Call VLEN (INPATH,LIN)
	    FITSEXT = INPATH(IHDU+1:LIN)
	    Call PADNULL (FITSEXT)
	    Call VLEN (FITSEXT,LEXT)
	    Call ISNUM (FITSEXT, NUMEXT)
	    If (NUMEXT) Then
		Call ASCBINI4 (LEXT,FITSEXT,FITSHDU,IER)
	    Else
		FITSHDU = -2
	    Endif
	    Endif
90	IFD = -1
	If (IHDU .ne. 0) INPATH(IHDU:IHDU) = Char (0)
	Call OPENR (IFD,INPATH)
	Call VLEN (INPATH,LIN)
	If (IHDU .ne. 0) Then
	    Call CONSTR (INPATH, ',')
	    Call CONSTR (INPATH, FITSEXT)
	    Endif
	If (IFD .lt. 3) Then
	    If (NTRY .lt. 3) Then
		NTRY = NTRY + 1
		Go to 90
	    Else
		Write(*,94) INPATH(1:LIN)
94		Format('*** FITSRHEAD:  Cannot read file "',A,'"')
		Return
	    Endif
	Elseif (VERBOSE) Then
	    Write(*,95) INPATH(1:LIN)
95	    Format('FITSRHEAD:  Input file "',A,'"opened')
	Endif

	NBYTES = 28800
	IH0 = 1
	IH1 = 2880
	NBHEAD = 0
	FITSSKIP = 0

c  Read FITS header from input file one FITS block at a time
100	NBYTES = 2880
	NTRY = 0
105	Call SGETC (IFD,NBYTES,FITSBUF,NBR)
	Call HSEARCH (FITSBUF,'END',IEND)
	If ((NBR .lt. NBYTES) .and. (IEND .eq. 0)) Then
	    If (NTRY .lt. 10) Then
		NTRY = NTRY + 1
		If (VERBOSE) Then
		    Write(*,*) 'FITSRHEAD: ',NBR,'/',NBYTES,' bytes read',NTRY
		    Endif
		Go to 105
	    Else
		Write(*,110) NBR,NBYTES,INPATH(1:LIN)
110		Format('FITSRHEAD: ',I5,'/',I5,' bytes of header read from ',A)
		Call SCLOSE (IFD,IER)
		Return
	    Endif
	    Endif

c  Move current FITS record into header string
	If (IEND .eq. 0) Then
	    HEADER(IH0:IH1) = FITSBUF(1:NBR)
	    IH0 = IH0 + NBR
	    IH1 = IH1 + NBR
	    NBHEAD = NBHEAD + NBR
	    Go to 100
	Else
	    NBENTRY = ((IEND / 2880) + 1) * 2880
	    IH1 = IH0 + NBENTRY - 1
	    HEADER(IH0:IH1) = FITSBUF(1:NBENTRY)
	    NBHEAD = NBHEAD + NBENTRY
	Endif

c  If this header has no data and has not been requested, read the next one
	Call HGETI4 (HEADER,'NAXIS',NAXIS)
	Call HGETL (HEADER,'EXTEND',EXTEND)
	If ((NAXIS .eq. 0) .and. (FITSHDU .eq. -1) .and. (EXTEND)) Then
	    NHDU = NHDU + 1
	    IH0 = 1
	    IH1 = 2880
	    PHEADER = HEADER
	    Go to 100
	    Endif

	If (FITSHDU .lt. -1) Then
	    Call HGETC (HEADER,'EXTNAME',EXTNAME)
	    If (EXTNAME .eq. FITSEXT) Then
		NEWHDU = .false.
	    Else
		NEWHDU = .true.
	    Endif
	Elseif ((FITSHDU .ge. 0) .and. (NHDU .lt. FITSHDU)) Then
	    NEWHDU = .true.
	Else
	    NEWHDU = .false.
	Endif

	If (NEWHDU) Then
	    NHDU = NHDU + 1
	    Call HGETI4 (HEADER,'BITPIX',IBPIX)
	    If (IBPIX .gt. 0) Then
		NBPIX = IBPIX / 8
	    Else
		NBPIX = -IBPIX / 8
	    Endif
	    Call HGETI4 (HEADER,'NAXIS',NAX)
	    If (NAX .le. 0) Then
		NBSKIP = 0
	    Else
		NBSKIP = 1
	    Endif
	    If (NAX .gt. 0) Then
		NAX1 = 0
		Call HGETI4 (HEADER,'NAXIS1',NAX1)
		NBSKIP = NBSKIP * NAX1
		Endif
	    If (NAX .gt. 1) Then
		NAX2 = 1
		Call HGETI4 (HEADER,'NAXIS2',NAX2)
		NBSKIP = NBSKIP * NAX2
		Endif
	    If (NAX .gt. 2) Then
		NAX3 = 1
		Call HGETI4 (HEADER,'NAXIS3',NAX3)
		NBSKIP = NBSKIP * NAX3
		Endif
	    If (NAX .gt. 3) Then
		NAX4 = 1
		Call HGETI4 (HEADER,'NAXIS4',NAX4)
		NBSKIP = NBSKIP * NAX4
		Endif
	    NBSKIP = NBSKIP * NBPIX
	    NBLOCK = NBSKIP / 2880
	    If (NBLOCK * 2880 .lt. NBSKIP) NBLOCK = NBLOCK + 1
	    FITSSKIP = FITSSKIP + NBHEAD + (NBLOCK * 2880)
	    Call SPOS (IFD, FITSSKIP, IPOS)
	    If (IPOS .ne. FITSSKIP) Then
		Write(*,*) 'FITSRHEAD:',IPOS,' / ',FITSSKIP,' bytes skipped'
		NBHEAD = 0
		Call SCLOSE (IFD,IER)
		Return
	    Else
		IH0 = 1
		IH1 = 2880
		NBHEAD = 0
		Go to 100
	    Endif
	    Endif

c  Append Primary Header to Table Header
	If (PHEADER(1:1) .ne. Char (0)) Then
	    Call HSEARCH (HEADER, 'END', IEND)
	    Call HSEARCH (PHEADER, 'END', JEND)
	    LPHEAD = JEND + 79
	    HEADER(IEND:IEND+LPHEAD-1) = PHEADER(1:LPHEAD)
	    Endif

	Call SCLOSE (IFD,IER)
	If (IER .ne. 0) Write(*,*) 'FITSRHEAD:  File close error',IER

	Return
	End


	Subroutine FITSRHDU (HDU)

	Integer*4 HDU

	Include 'fitshead.cmb'

	FITSHDU = HDU
	Return
	End

c Jul 18 1991	Use standard IO instead of stream IO

c Feb 25 1993	Drop unused variables nfile and tape

c Jul  5 1994	If 'END' is found, accept final small block
c Dec 21 1994	If record short, print filename

c Jan  5 1995	Return with nbhead=0 if there is a file reading error

c Jan 29 1997	Read header for specific Header/Data unit
c Feb 20 1997	Change name of HDU variable from hdu to fitshdu
c Mar  4 1997	Add header/data unit-setting subroutine; null out header
c Apr 16 1997	Declare undeclated variables ibpx and nblock
c Oct  9 1997	Read specific header/data unit as filename,hdu

c Jul 23 1998	Declare undeclared variables
c Aug 19 1998	Append Primary Header if it has no data
c Aug 20 1998	Declare undeclared variables
