c*** File fitslib/fitsrtopen.f
c*** March 4, 1997
c*** By Doug Mink, Center for Astrophysics

	Subroutine FITSRTOPEN (INPATH, HEADER, NBHEAD, IFD)

	Character*(*) INPATH
c				Pathname for FITS tables file to read
	Character*(*) HEADER
c				Header for FITS tables file to read
	Integer*4 NBHEAD
c				Number of bytes of header information
c				This includes the first, simple header block
	Integer*4 IFD
c				File descriptor for FITS tables file

	Logical EXTEND
	Integer*4 LIN,NBYTES,IH0,IH1,IEND,NBENTRY,NAXIS
	Integer*4 NTRY,NBR, LHEAD
	Character*2880 FITSBUF
	Character*10 TEMP

	Common/RTAB/ OFFSET1, OFFSET2
	Integer*4 OFFSET1,OFFSET2

	Include 'header.cmb'
	Include 'fitshead.cmb'

c  Open input file

	OFFSET1 = 0
	OFFSET2 = 0
	NTRY = 0
90	IFD = -1
	Call OPENR (IFD,INPATH)
	Call VLEN (INPATH,LIN)
	If (IFD .lt. 3) Then
	    If (NTRY .lt. 3) Then
		NTRY = NTRY + 1
		Go to 90
	    Else
		Write(*,94) INPATH(1:LIN)
94		Format('FITSRTOPEN:  Cannot read file "',A,'"')
		Stop
	    Endif
	Elseif (VERBOSE) Then
	    Write(*,95) INPATH(1:LIN)
95	    Format('FITSRTOPEN:  Input file "',A,'"opened')
	Endif

	NBYTES = 28800
	IH0 = 1
	IH1 = 2880
	NBHEAD = 0
	Call ZSTRING (HEADER)
	LHEAD = Len (HEADER)

c  Read FITS header from input file one FITS block at a time

100	NBYTES = 2880
	NTRY = 0
105	Call SGETC (IFD,NBYTES,FITSBUF,NBR)
	If (NBR .lt. NBYTES) Then
	    If (NTRY .lt. 10) Then
		NTRY = NTRY + 1
		If (VERBOSE) Then
		    Write(*,110) NBR,NBYTES,NTRY
110		    Format('FITSRTOPEN: ',I5,' /',I5,' bytes read',I3)
		    Endif
		Go to 105
	    Else
		Write(*,120) NBR,NBYTES,INPATH(1:LIN)
120		Format('FITSRTOPEN: ',I5,' /',I5,' header bytes, file "',A,'"')
		Stop
	    Endif
	    Endif

c  Move current FITS record into header string
	Call HSEARCH (FITSBUF,'END',IEND)
	If (IEND .eq. 0) Then
	    If (IH1 .le. LHEAD) Then
		HEADER(IH0:IH1) = FITSBUF(1:NBR)
	    Elseif (IH0 .le. LHEAD) Then
		IH1 = LHEAD
		NBENTRY = IH1 - IH0 + 1
		HEADER(IH0:IH1) = FITSBUF(1:NBENTRY)
	    Endif
	    IH0 = IH0 + NBR
	    IH1 = IH1 + NBR
	    NBHEAD = NBHEAD + NBR
	    Go to 100
	Else
	    NBENTRY = ((IEND / 2880) + 1) * 2880
	    IH1 = IH0 + NBENTRY - 1
	    If (IH1 .le. LHEAD) Then
		HEADER(IH0:IH1) = FITSBUF(1:NBENTRY)
		NBHEAD = NBHEAD + NBENTRY
	    Elseif (IH0 .le. LHEAD) Then
		IH1 = LHEAD
		NBENTRY = IH1 - IH0 + 1
		HEADER(IH0:IH1) = FITSBUF(1:NBENTRY)
		NBHEAD = NBHEAD + NBENTRY
	    Endif
	Endif

c  If this is not the real header, start with next record
	Call HGETI4 (HEADER,'NAXIS',NAXIS)
	Call HGETL (HEADER,'EXTEND',EXTEND)
	If ((NAXIS .eq. 0) .and. (EXTEND)) Then
	    IH0 = 1
	    IH1 = 2880
	    Go to 100
	    Endif

c  Make sure this file is really a FITS table file
	Call HGETC (HEADER,'XTENSION',TEMP)
	If ((TEMP(1:5) .ne. 'TABLE') .and. (TEMP(1:8) .ne. 'BINTABLE')) Then

c  Try next header/data unit if this is not a table
	    If (NDU .lt. 1) Then
		FITSHDU = 2
	    Else
		FITSHDU = FITSHDU + 1
	    Endif
	    IH0 = 1
	    IH1 = 2880
	    Call ZSTRING (HEADER)
	    Go to 100
	    Endif

	Return
	End

c Apr 23 1991	Switch to stream I/O
c Jul 24 1991	Switch back to standard I/O
c Dec 18 1991	Reset OFFSETs for FITSRTLINE

c Feb 12 1992	Print file name for header reading error

c Feb 25 1993	Drop unused variables nfile and tape

c Jan 29 1997	Implement FITS binary tables and multiple HDUs
c Mar  4 1997	Check header string length; fix multiple HDU code
