c*** File fitslib/fitsrthead.f
c*** By Doug Mink, Center for Astrophysics
c*** November 8, 2001

	Subroutine FITSRTHEAD (INPATH,HEADER,NK,KNUM,KNAME,KFIRST,KLAST,KFORM)

	Character*(*) INPATH
c				Pathname for FITS tables file to read
	Character*(*) HEADER
c				Header for FITS tables file to read
	Integer*4 NK
c				Number of keywords to use
	Integer*4 KNUM(*)
c				Indices of desired keywords
	Character*(*) KNAME(*)
c				List of keywords to use
	Integer*4 KFIRST(*)
c				Starting postion of desired keywords (returned)
	Integer*4 KLAST(*)
c				Final postion of desired keywords (returned)
	Character*(*) KFORM(*)
c				Formats of keywords in file (returned)

	Integer*4 PFIRST(100)
c				Indices of first characters of table entries
	Integer*4 PLAST(100)
c				Indices of last characters of table entries
	Character*10 PFORM(100), TFORM, TFORM0
c				Formats of table entries
	Character*10 PNAME(100), TNAME
c				Names of table entries
	Integer*4 LPNAM(100)
c				Length of name for each field

	Integer*4 LIN,IH0,NFIELDS,NBHEAD,NENTRY,NCOL
	Integer*4 NLEFT,IFIELD,IPT,LF0,LFL,LFIELD,IER,IK,LT,LN,LNM
	Character*20 TEMP
	Character*100 STRING
	Logical TVERB, BINTABLE

	Include 'header.cmb'
	Include 'fitshead.cmb'

c  Read FITS header from input file
100	Call FITSRHEAD (INPATH, HEADER, NBHEAD)
	Call VLEN (INPATH,LIN)
	If (NBHEAD .eq. 0) Then
	    Write(*,110) INPATH(1:LIN)
110	    Format('FITSRTHEAD: "',A,'" is not a FITS Table file')
	    Stop
	    Endif

c  Make sure this file is really a FITS table file
	Call ZSTRING (TEMP)
	Call HGETC (HEADER,'XTENSION', FITSTYPE)
	If ((FITSTYPE(1:5) .ne. 'TABLE') .and.
     1	    (FITSTYPE(1:8) .ne. 'BINTABLE')) Then

c  Try next header/data unit if this is not a table
	    If (FITSHDU .lt. 2) Then
		FITSHDU = 2
	    Else
		FITSHDU = FITSHDU + 1
	    Endif
	    Go to 100
	    Endif

	If (FITSTYPE(1:8) .eq. 'BINTABLE') Then
	    BINTABLE = .true.
	Else
	    BINTABLE = .false.
	Endif

c  Set up table for access to individual fields
	Call HGETI4 (HEADER,'TFIELDS',NFIELDS)
	If (VERBOSE) Write(*,*) NFIELDS,' fields per table entry'
	IH0 = 1
	NLEFT = NK
	TVERB = VERBOSE
	VERBOSE = .false.
	NCOL = 0
	Do 170 IFIELD = 1, NFIELDS
	    If (NLEFT .le. 0) Go to 200

c	Get first header entry for this column
	    If (BINTABLE) Then
		TNAME = 'TFORM'
	    Else
		TNAME = 'TBCOL'
	    Endif
	    If (IFIELD .lt. 10) Then
		Write(TEMP,161) TNAME, IFIELD
161		Format(A5,I1)
	    Elseif (IFIELD .lt. 100) Then
		Write(TEMP,162) TNAME, IFIELD
162		Format(A5,I2)
	    Else
		Write(TEMP,163) TNAME, IFIELD
163		Format(A5,I3)
	    Endif
	    Call HSEARCH (HEADER(IH0:),TEMP,IPT)
	    If (.not. BINTABLE) Then
		Call HGETI4 (HEADER(IH0:),TEMP,PFIRST(IFIELD))
		TEMP(2:5) = 'FORM'
		Endif
	    Call HGETC (HEADER(IH0:),TEMP,PFORM(IFIELD))
	    Call VLEN (PFORM(IFIELD),LF0)

c	Get width of this column
	    If (BINTABLE) Then
		PFIRST(IFIELD) = NCOL
		If (Index (PFORM(IFIELD),'E') .gt. 0) Then
		    Call ASCBINI4 (1,PFORM(IFIELD),NENTRY,IER)
		    PLAST(IFIELD) = NCOL + (4 * NENTRY)
		    NCOL = NCOL + (4 * NENTRY)
		Elseif (Index (PFORM(IFIELD),'D') .gt. 0) Then
		    Call ASCBINI4 (1,PFORM(IFIELD),NENTRY,IER)
		    PLAST(IFIELD) = NCOL + (8 * NENTRY)
		    NCOL = NCOL + (8 * NENTRY)
		Elseif (Index (PFORM(IFIELD),'I') .gt. 0) Then
		    Call ASCBINI4 (1,PFORM(IFIELD),NENTRY,IER)
		    PLAST(IFIELD) = NCOL + (2 * NENTRY)
		    NCOL = NCOL + (2 * NENTRY)
		Elseif (Index (PFORM(IFIELD),'J') .gt. 0) Then
		    Call ASCBINI4 (1,PFORM(IFIELD),NENTRY,IER)
		    PLAST(IFIELD) = NCOL + (4 * NENTRY)
		    NCOL = NCOL + (4 * NENTRY)
		Elseif (Index (PFORM(IFIELD),'B') .gt. 0) Then
		    Call ASCBINI4 (1,PFORM(IFIELD),NENTRY,IER)
		    PLAST(IFIELD) = NCOL + NENTRY
		    NCOL = NCOL + NENTRY
		Elseif (Index (PFORM(IFIELD),'L') .gt. 0) Then
		    Call ASCBINI4 (1,PFORM(IFIELD),NENTRY,IER)
		    PLAST(IFIELD) = NCOL + NENTRY
		    NCOL = NCOL + NENTRY
		Endif
	    Else
		LFL = Index (PFORM(IFIELD),'.') - 1
		If (LFL .lt. 0) LFL = LF0
		TFORM = PFORM(IFIELD)
		Call ASCBIN (LFL-1,TFORM(2:),-14,LFIELD,IER)
		PLAST(IFIELD) = PFIRST(IFIELD) + LFIELD - 1
	    Endif
	    TEMP(2:5) = 'TYPE'
	    Call HGETC (HEADER(IH0:),TEMP,PNAME(IFIELD))
	    Call PADNULL (PNAME(IFIELD))
	    Call VLEN (PNAME(IFIELD),LPNAM(IFIELD))
c	    If (VERBOSE) Then
c		LN = LPNAM(IFIELD)
c		Call VLEN (PFORM(IFIELD),LF0)
c		TNAME = PNAME(IFIELD)
c		If (VERBOSE) Write(*,165) IFIELD,TNAME(1:LN),
c     1		    TFORM(1:LF0),PFIRST(IFIELD),PLAST(IFIELD)
c165		Format(I3,1x,A8,1x,A8,I5,' -',I5)
c		Endif
	    IH0 = IH0 + IPT - 1
170	    Continue

c  Set up table for access to desired fields

c   Open output keyword file, checking to see whether it can be written
200	VERBOSE = TVERB
	STRING = 'Keywords from $'
	Call CONSTR (STRING,INPATH(1:LIN))
	Call PADNULL (STRING)
	If (VERBOSE) Call PSTRING (STRING)
	Do 210 IK = 1, NK
	    If (KNUM(IK) .le. 0) Then
		TEMP = KNAME(IK)
		Call VLEN (TEMP, LT)
		Call PADNULL (TEMP)
		Do 205 IFIELD = 1, NFIELDS
		    TNAME = PNAME(IFIELD)
		    LN = LPNAM(IFIELD)
		    If (TEMP(1:LT) .eq. TNAME(1:LN)) Then
			KNUM(IK) = IFIELD
			Go to 206
			Endif
205		    Continue
206		IFIELD = KNUM(IK)
	    Else
		IFIELD = KNUM(IK)
	    Endif
	    KFIRST(IK) = PFIRST(IFIELD)
	    KLAST(IK) = PLAST(IFIELD)
	    If (IFIELD .le. 0) Go to 207
	    KNAME(IK) = PNAME(IFIELD)
	    TNAME = KNAME(IK)
	    LNM = LPNAM(IFIELD)

c  Set input format for this field
	    If (BINTABLE) Then
		KFORM(IK) = PFORM(IFIELD)
	    Else
		TFORM0 = '('
		Call PADNULL (TFORM0)
		Call CONSTR (TFORM0,PFORM(IFIELD))
		Call CONSTR (TFORM0,')')
		Call VLEN (TFORM0, LF0)
		KFORM(IK) = TFORM0
	    Endif

207	    If (VERBOSE) Then
		Write(STRING,208) IK,KNUM(IK),TNAME(1:LNM),TFORM0(1:LF0),
     1				  KFIRST(IK),KLAST(IK)
208		Format(I3,I4,1x,A8,1x,A8,I5,' -',I5)
		Call PADNULL (STRING)
		Call PSTRING (STRING)
		Endif
210	    Continue

	Return
	End

c Apr 19 1991	Call FITSRTOPEN to read FITS header
c Apr 23 1991	Switch to stream I/O
c Apr 29 1991	Call FITSRHEAD to read FITS header
c Jul 11 1991	Set LIN

c Jan 27 1993	Drop all reference to keyword file; turn off VERBOSE

c Jan  5 1995	Stop if header cannot be read

c Jan 29 1997	Add binary table access
c Feb 20 1997	Change name of HDU variable from hdu to fitshdu
c Feb 21 1997	Fix bug in bintable switch setting
c Feb 26 1997	Drop through loop if keyword not found
c Mar  4 1997	Fix error message
c Apr  1 1997	Declare undeclared variable ncol

c Aug 18 1998	Keep extension type in common
c Aug 19 1998	Add J format for BINTABLE; fix comparison of column names

c Nov  8 2001	Fix initialization problem with LIN thanks to Chip Coldwell
