c*** File fitslib/fitswhead.f
c*** March 21, 1991
c*** By Doug Mink

c--- Write FITS header and data after opening a data file
c    Print extra information if VERBOSE in /HEADER/ common is set.

	Subroutine FITSWHEAD (FNAME,HSTRING,NBR)

	Character*(*) FNAME
c				File name
	Character*(*) HSTRING
c				Header string
	Integer*4 NBR
c				Number of header blocks read

	Integer*4 IFIL
c				UNIX file from which to read

	Integer*4 NC, NBW, NAXIS, NAXIS1, NAXIS2, BITPIX, NBPIX,NR,IBO
	Integer*4 NW, IEND,NAXIS3,NI,NLEFT,NB,IFI,IFO,IBI,I,IB,IPOS,IER
	Integer*4 FITSBUF(720)

	Include 'header.cmb'

	Call ESET

c  Open data file, returning if not possible

	IFIL = -2
	Call OPENW (IFIL,FNAME)
	IF (IFIL .lt. 3) Return
	Call SCLOSE (IFIL, IER)

c  Compute number of bytes to write

	Call HSEARCH (HSTRING,'END',IEND)
	NC = IEND + 3
	NBW = 2880 * (NC / 2880)
	If (NBW .lt. NC) NBW = NBW + 2880

c  If number of bytes being written is greater than number read, shift file

	If (NBW .gt. NBR) Then

c  Compute number of blocks in image

	    Call HGETI4 (HSTRING,'BITPIX',BITPIX)
	    Call HGETI4 (HSTRING,'NAXIS',NAXIS)
	    Call HGETI4 (HSTRING,'NAXIS1',NAXIS1)
	    NBPIX = BITPIX / 8
	    NI = NAXIS1 * NBPIX / 2880
	    If (NAXIS .gt. 1) Then
		Call HGETI4 (HSTRING,'NAXIS2',NAXIS2)
		NI = NI * NAXIS2
		Endif
	    If (NAXIS .gt. 2) Then
		Call HGETI4 (HSTRING,'NAXIS3',NAXIS3)
		NI = NI * NAXIS3
		Endif
	    NLEFT = 2880 * ((NI / 2880) + 1) - NI
	    If (NLEFT .lt. 2880) NI = NI + NLEFT
	    NB = NI / 2880

c  Shift image in place by one block so that the revised header will fit

	    IFI = -2
	    Call OPENR (IFI,FNAME)
	    IF (IFI .lt. 3) Return
	    IFO = -2
	    Call OPENW (IFO,FNAME)
	    IF (IFO .lt. 3) Return
	    IBI = NBR + NI
	    Do 100 I = 1, NB
		IBI = IBI - 2880
		Call SPOS (IFI,IB,IPOS)
		Call SGET (IFI,2880,FITSBUF,NR)
		IBO = IBI + 2880
		Call SPOS (IFO,IBO,IPOS)
100		Call SPUT (IFO,2880,FITSBUF,NW)
	    Call SCLOSE (IFI, IER)
	    Call SCLOSE (IFO, IER)
	    If (VERBOSE) Then
		Write(*,140) NI
140		Format('FITSWHEAD: ',I7,' bytes shifted by one block')
		Endif

	    Endif

c  Write FITS header

	IFIL = -2
	Call OPENW (IFIL,FNAME)
	IF (IFIL .lt. 3) Then
	    Write(*,204) FNAME
204	    Format('FITSWHEAD: Cannot open file "',A,'" to write')
	    Call PCHAR (13)
	    Return
	    Endif
	Call SPUTC (IFIL,NBW,HSTRING,NW)
	If (NW .lt. NBW) Then
	    Write(*,205) NW,NBW,FNAME
205	    Format('FITSWHEAD: Only',I5,'/',I5,' bytes written to "',A,'"')
	    Call PCHAR (13)
	    Return
	    Endif
	Call SCLOSE (IFIL, IER)

	If (VERBOSE) Write(*,110) NC,FNAME
110	Format('FITSWHEAD:',I5,'-byte header written to file "',A,'"')

	Return
	End
