c*** File fitslib/fitswtline.f
c*** March 18, 1994
c*** By Doug Mink, Center for Astrophysics

	Subroutine FITSWTLINE (IFD, NBHEAD, TBUFF, IROW, NBLINE, LINE)

	Integer*4 IFD
c				File descriptor for FITS file
	Integer*4 NBHEAD
c				Number of bytes in FITS header
	Character*(*) TBUFF
c				FITS table
	Integer*4 IROW
c				Number of table row to write
	Integer*4 NBLINE
c				Number of bytes to write for this line
	Character*(*) LINE
c				FITS table line to write

	Integer*4 LBUFF,NBUFF,NLBUFF,IPOS,NBR,OFFSET

	Include 'header.cmb'

	Common/WTAB/ OFFSET1, OFFSET2
	Integer*4 OFFSET1,OFFSET2
	Data OFFSET1/0/, OFFSET2/0/

	OFFSET = NBHEAD + (NBLINE * (IROW - 1))

c  Write the FITS table buffer from memory if it is full

	If ((OFFSET .lt. OFFSET1) .or. (OFFSET .gt. OFFSET2)) Then
	    NBUFF = OFFSET2 - OFFSET1 + 1
	    IPOS = 0
	    Call SPOS (IFD,OFFSET1,IPOS)
	    Call SPUTC (IFD,NBUFF,TBUFF,NBW)
	    If (NBW .lt. NBUFF) Then
		Return
		Endif
	    LBUFF = Len (TBUFF)
	    Call ZSTRING (TBUFF)
	    NLBUFF = LBUFF / NBLINE
	    NBUFF = NLBUFF * NBLINE
	    OFFSET1 = OFFSET
	    OFFSET2 = OFFSET + NBUFF - 1
	    Endif

	TBUFF(OFFSET-OFFSET1+1:OFFSET-OFFSET1+NBLINE) = LINE(1:NBLINE)

	Return
	End

	Subroutine FITSWTINIT (NBHEAD, TBUFF, NBLINE)

	Integer*4 NBHEAD
c				Number of bytes in FITS header
	Character*(*) TBUFF
c				FITS table
	Integer*4 NBLINE
c				Number of bytes to write for this line

	Integer*4 LBUFF,NLBUFF,NBUFF

	Common/WTAB/ OFFSET1, OFFSET2
	Integer*4 OFFSET1,OFFSET2

	OFFSET1 = NBHEAD

	LBUFF = Len (TBUFF)
	NLBUFF = LBUFF / NBLINE
	NBUFF = NLBUFF * NBLINE
	OFFSET2 = NBUFF

	Return
	End


	Subroutine FITSWTBUFF (IFD, TBUFF)

	Integer*4 IFD
c				File descriptor for FITS file
	Character*(*) TBUFF
c				FITS table

	Integer*4 LBUFF,NLBUFF,NBUFF

	Common/WTAB/ OFFSET1, OFFSET2
	Integer*4 OFFSET1,OFFSET2

	Call VLEN (TBUFF,LBUFF)
	OFFSET2 = OFFSET1 + LBUFF - 1

	Call SPOS (IFD,OFFSET1,IPOS)
	Call SPUTC (IFD,NBUFF,TBUFF,NBW)
	If (NBW .lt. NBUFF) Then
		Return
		Endif
	LBUFF = Len (TBUFF)
	Call ZSTRING (TBUFF)
	NLBUFF = LBUFF / NBLINE
	NBUFF = NLBUFF * NBLINE
	OFFSET1 = OFFSET2 + 1
	OFFSET2 = OFFSET1 + NBUFF - 1
	Return
	End
