c*** File fitslib/hsearch.f
c*** August 20, 1998
c*** By Doug Mink, Center for Astrophysics

	Subroutine HSEARCH (HSTRING,VNAME,PVAL)

c*** Find entry for keyword VNAME in FITS-like header string HSTRING.
c   (The keyword may have a maximum of eight letters)

	Character*(*) HSTRING
c			Character string containing FITS-style header information
c			in the format <VNAME>= <value> {/ <comment>}
c			The default is that each entry is 80 characters long;
c			however, lines may be of arbitrary length terminated by
c			nulls, carriage returns or linefeeds, if PACKED is .true..
	Character*(*) VNAME
c			Character string containing the name of the variable
c			to be returned.  HSEARCH searches for a line beginning
c			with this string.
c			The string may be a character literal or a Character
c			variable terminated by a NULL or '$'.  It is
c			truncated to 8 characters.
	Integer*4 PVAL
c			Fortran index of position in HSTRING at which entry for
c			variable VNAME starts.
c			If VNAME is not found, a value of 0 is returned.

	Integer*4 LVNAME,LHSTR,ISTART,LOC,L0,NEXTCHAR,NLINE,ICOL0,ICOL
	Integer*4 PREVCHAR, IVC

	Include 'header.cmb'

	PVAL = 0

c  Find length of variable name

	Call VLEN (VNAME,LVNAME)

c  Check for COMMENT keyword with colon following

	IVC = Index (VNAME,':')
	If (IVC .gt. 0) Then
	    LVNAME = LVNAME - 1
	Elseif (LVNAME .gt. 8) Then
	    LVNAME = 8
	Endif

c  Search header string for variable name

	LHSTR = Len (HSTRING)
	ISTART = 1
30	If (ISTART .gt. LHSTR) Then
c	    If (VERBOSE) Then
c		Write(LINE,31) VNAME(1:LVNAME)
c31		Format('HSEARCH: "',A,'" not found$')
c		Call PSTRING (LINE)
c		Endif
	    Return
	    Endif
	LOC = Index (HSTRING(ISTART:),VNAME(1:LVNAME))

c  Exit if not found

	If (LOC .eq. 0) Then
	    Return
	    Endif

c  If parameter name in string entry is longer, keep searching

	L0 = LOC + ISTART - 1
	NEXTCHAR = Ichar (HSTRING(L0+LVNAME:L0+LVNAME))
	If ((NEXTCHAR.ne.61) .and. (NEXTCHAR.ne. 58).and.(NEXTCHAR.gt.32)
     1	    .and.(NEXTCHAR.lt.127)) Then
	    ISTART = L0 + 1
	    Go to 30
	    Endif


c  See if this is a legal position for a keyword.  If not, assume it is in
c  the comment or value  field, and keep searching.

	NLINE = L0 / 80
	ICOL0 = (80 * NLINE) + 1
	ICOL = L0 - ICOL0
	If (IVC .gt. 0) Then
	    PVAL = ICOL0
	Elseif (ICOL .gt. 8) Then
	    ISTART = L0 + 1
	    Go to 30
	Elseif (ICOL .gt. 1) Then
	    PREVCHAR = Ichar (HSTRING(L0-1:L0-1))
	    If ((PREVCHAR.gt.32) .and. (PREVCHAR.lt.127)) Then
		ISTART = L0 + 1
		Go to 30
		Endif
	Else
	    PVAL = ICOL0
	Endif

c  Return to calling program

	Return
	End

c Sep  6 1984	Replace tedious string searches with Fortran Index calls.
c		(This is a major rewrite of the entire subroutine.)

c Apr 10 1985	Eliminate extraneous newlines
c Apr 11 1985	Allow / to be read as part of string, at least if packed
c Jul 31 1985	Clean up code; include "header.cmb" instead of declaring common

c Jul 10 1986	Use PSTRING for error messages (works in raw or cooked mode)

c Feb  9 1987	Keep / in string only if not surrounded by spaces
c Jul 24 1987	Change to work only for FITS headers; return start of entry only

c Mar  3 1988	Fix bug which failed to compare all characters in string

c May 18 1990	Fix bug which failed to check characters in string before match

c Mar 21 1991	Declare all variables

c Dec  5 1994	If : in parameter name, allow parameter in comment

c Aug 20 1998	Drop unused variables
