c*** File fitslib/tabget.f
c*** September 18, 2003
c*** By Doug Mink, Harvard-Smithsonian Center for Astrophysics

c TABGETR8 (ENTRY, KFIRST, KFORM, DNUM)
c	Return Real*8 value for single table entry

c TABGETR4 (ENTRY, KFIRST, KFORM, RNUM)
c	Return Real*4 value for single table entry

c TABGETI4 (ENTRY, KFIRST, KFORM, DNUM)
c	Return Integer*4 value for single table entry


	Subroutine TABGETR8 (ENTRY, KFIRST, KFORM, DNUM)

	Character*(*) ENTRY
	Integer*4 KFIRST
	Character*(*) KFORM
	Real*8 DNUM

	Real*4 RNUM
	Integer*4 INUM
	Integer*2 JNUM

	If (KFORM(1:2) .eq. '1D') Then
	    Call STGETR8 (ENTRY, KFIRST, DNUM)
	Elseif (KFORM(1:2) .eq. '1E') Then
	    Call STGETR4 (ENTRY, KFIRST, RNUM)
	    DNUM = Dble (RNUM)
	Elseif (KFORM(1:2) .eq. '1J') Then
	    Call STGETI4 (ENTRY, KFIRST, INUM)
	    DNUM = Dble (INUM)
	Elseif (KFORM(1:2) .eq. '1I') Then
	    Call STGETI2 (ENTRY, KFIRST, JNUM)
	    DNUM = Dble (JNUM)
	Else
	    DNUM = 0.d0
	Endif
	Return
	End


	Subroutine TABGETR4 (ENTRY, KFIRST, KFORM, RNUM)

	Character*(*) ENTRY
	Integer*4 KFIRST
	Character*(*) KFORM
	Real*4 RNUM

	Real*8 DNUM
	Integer*4 INUM
	Integer*2 JNUM

	If (KFORM(1:2) .eq. '1D') Then
	    Call STGETR8 (ENTRY, KFIRST, DNUM)
	    RNUM = Sngl (DNUM)
	Elseif (KFORM(1:2) .eq. '1E') Then
	    Call STGETR4 (ENTRY, KFIRST, RNUM)
	Elseif (KFORM(1:2) .eq. '1J') Then
	    Call STGETI4 (ENTRY, KFIRST, INUM)
	    RNUM = Float (INUM)
	Elseif (KFORM(1:2) .eq. '1I') Then
	    Call STGETI2 (ENTRY, KFIRST, JNUM)
	    RNUM = Float (JNUM)
	Else
	    RNUM = 0.d0
	Endif
	Return
	End


	Subroutine TABGETI4 (ENTRY, KFIRST, KFORM, INUM)

	Character*(*) ENTRY
	Integer*4 KFIRST
	Character*(*) KFORM
	Integer*4 INUM

	Integer*2 JNUM
	Real*8 DNUM
	Real*4 RNUM

	If (KFORM(1:2) .eq. '1J') Then
	    Call STGETI4 (ENTRY, KFIRST, INUM)
	Elseif (KFORM(1:2) .eq. '1I') Then
	    Call STGETI2 (ENTRY, KFIRST, JNUM)
	    INUM = JNUM
	Elseif (KFORM(1:2) .eq. '1E') Then
	    Call STGETR4 (ENTRY, KFIRST, RNUM)
	    INUM = Nint (RNUM)
	Elseif (KFORM(1:2) .eq. '1D') Then
	    Call STGETR8 (ENTRY, KFIRST, DNUM)
	    INUM = Idnint (DNUM)
	Else
	    INUM = 0
	Endif
	Return
	End

c Aug 21 1998	New subroutine
c Sep 18 1998	Add TABGETR4

c Sep 18 2003	Change float(double) call to sngl()
c Sep 18 2003	Call stgetr8() for all real*8 returns
