c*** File iolib/binasc.f
c*** August 20, 1998
c*** By Doug Mink

c--- Subroutines to translate binary variables to ASCII strings

c	BINASC (NCHAR,LINE,ITYPE,INVAL,IER) translates any type
c	BINASCI4 (IVAL,STRING) translates Integer*4 to string
c	BINASCI2 (IVAL,STRING) translates Integer*2 to string
c	BINASCL (IVAL,STRING) translates Logical to string
c	BINASCR4 (RVAL,STRING) translates Real*4 to string
c	BINASCR8 (DVAL,STRING) translates Real*8 to string
c	BINASNR8 (DVAL,N,STRING) translates Real*8 to string with N decimal places

c--- BINASC Translate variable at address IVAL into ASCII string LINE.

	Subroutine BINASC (NCHAR,LINE,ITYPE,INVAL,IER)

	Integer*4 NCHAR
c		Number of characters in string (returned)

	Character*(*) LINE
c		Character string (returned)

	Integer*4 ITYPE
c		Type of variable to be translated (Integer*4)
c		First ':' treated as '.'; later ':'s and '.'s ignored.
c		Illegal characters, overflows, and underflows trapped. 
c		-1n: Integer n bytes long (Integer*n)
c		-2n: Floating point number n bytes long (Real*n)
c		-3n: Logical variable n bytes long (Logical*n) (t or f)
c		-4n: Logical variable n bytes long (Logical*n) (y or n)
c		1-99: string length, Character, padded with spaces
c		101-199: string length, Character, padded with nulls
c		201-236: number of single characters (200 added)
c			returned in array of 36 (A-Z,0-9) Integer*2
c			with array positions corresponding to letter
c			or number entered set to one.  Array is not
c			zeroed on entry.
c			Lower case letters are treated as upper case.
c		301-399: string length, Character, padded with nulls
c			Lower case letters are converted to upper case.

	Real*8 INVAL(*)
c		Address of number, character, array, or string to be translated
c		If a Character string, call with Equivalence'd Integer;
c		otherwise, Fortran adds another	invisible string length
c		to the calling parameter list and messes up everything.

	Integer*4 IER
c		Error code returned (0>OK)

	Logical LVAL
	Character JLINE*100,NULL*1,JCHR*1, FORM*10
	Integer*4 LL,NB,IC,MCHAR,LDVAL,NC,NDEC,LRVAL,I,IND,INP,NZ
	Character*1 CVAL(100)
	Integer*2 ICHR,JVAL(50)
	Integer*4 KVAL
	Real*4 VAL
	Common/BINA/ DVAL,IDUM
	Real*8 DVAL
	Integer*4 IDUM(24)
	Equivalence (CVAL,DVAL,VAL,KVAL,JVAL(1),LVAL)

	IER = 0

	NULL = Char (0)
	LL = Len (LINE)

c  Zero out character string to be returned

	Call ZSTRING (LINE)
	Call ZSTRING (JLINE)

	MCHAR = 99
	If (ITYPE .gt. 0) MCHAR = ITYPE - 100 * (ITYPE/100)
	If (MCHAR .gt. 99) MCHAR = 99
	If (ITYPE .eq. -1) MCHAR = 1
	If (MCHAR .gt. LL) MCHAR = LL

c  Compute number of bytes in binary variable to be translated

	If (ITYPE .lt. -1) NB = -ITYPE - 10*(-ITYPE/10)
	If (ITYPE .eq. -1) NB = 1
	If (ITYPE .gt. 0) NB = ITYPE - 100 * (ITYPE/100)
	If ((ITYPE .gt. 200) .and. (ITYPE .lt. 300)) NB = 72

c  Move variable to accessible form

	Call MOVEB (INVAL,DVAL,NB,0,0)

	NCHAR = 0

c  Switch array (return in alphabetical order)

	If ((ITYPE .gt. 200) .and. (ITYPE .lt. 300)) Then
	   NCHAR = 0
	   Do 100 IC = 1, 36
	      If ((JVAL(IC) .gt. 0) .and. (NCHAR .lt. MCHAR)) Then
	         NCHAR = NCHAR + 1
	         ICHR = IC + 64
	         If (IC .gt. 26) ICHR = IC + 21
	         LINE(NCHAR:NCHAR) = Char (ICHR)
	         Endif
100	      Continue

c  Character string

	Elseif (ITYPE .ge. -1) Then

c	Transfer string

	   Do 105 IC = 1, MCHAR
105	      LINE(IC:IC) = CVAL(IC)
	   If (MCHAR .lt. LL) LINE(MCHAR+1:MCHAR+1) = NULL

c	Find length of string

	   Call VLEN (LINE,NCHAR)

c  Logical

	Elseif (ITYPE .lt. -30) Then
	    NCHAR = 1
	    If (LVAL) Then
		If (ITYPE .lt. -40) Then
		    LINE(1:1) = 'Y'
		Else
		    LINE(1:1) = 'T'
		Endif
	    Else
		If (ITYPE .lt. -40) Then
		    LINE(1:1) = 'N'
		Else
		    LINE(1:1) = 'F'
		Endif
	    Endif

c  Floating point

	Elseif (ITYPE .lt. -20) Then

c	Double precision floating point (REAL*8)

	    If (ITYPE .eq. -28) Then
		If (DVAL .eq. 0.) Then
		    LDVAL = 0
		Else
		    LDVAL = Idnint (Dlog10 (Dabs (DVAL)))
		Endif
		If ((LDVAL .lt. 16) .and. (LDVAL .gt. -10)) Then
		    NC = 19
		    NDEC = 16 - LDVAL
		    If (NDEC .gt. 15) NDEC = 15
		    If (NDEC .lt. 10) Then
			Write(FORM,430) NC,NDEC
430			Format('(F',I2,'.',I1,')')
		    Else
			Write(FORM,431) NC,NDEC
431			Format('(F',I2,'.',I2,')')
		    Endif
		    Write(JLINE,FORM) DVAL
		Else
		    NC = 23
		    Write(JLINE,435) DVAL
435		    Format(G23.16)
		Endif

c	Single precision floating point (REAL*4)

	    Else
		If (VAL .eq. 0) Then
		    LRVAL = 0
		Else
		    LRVAL = Nint (Alog10 (Abs (VAL)))
		Endif
		If ((LRVAL .lt. 7) .and. (LRVAL .gt. -2)) Then
		    NC = 9
		    NDEC = 6 - LRVAL
		    If (LRVAL .lt. 0) NC = NDEC + 2
		    Write(FORM,440) NC,NDEC
440		    Format('(F',I1,'.',I1,')')
		    Write(JLINE,FORM) VAL
		Elseif ((LRVAL .lt. -1) .and. (LRVAL .gt. -7)) Then
		    NDEC = 3 - LRVAL
		    NC = NDEC + 2
		    Write(FORM,441) NC,NDEC
441		    Format('(F',I2,'.',I1,')')
		Elseif ((LRVAL .lt. -6) .and. (LRVAL .gt. -10)) Then
		    NDEC = 3 - LRVAL
		    NC = NDEC + 2
		    Write(FORM,442) NC,NDEC
442		    Format('(F',I2,'.',I2,')')
		Else
		    NC = 14
		    Write(JLINE,445) VAL
445		    Format(G14.7)
		Endif
	    Endif

c	Remove leading blanks; ignore trailing blanks

	    NCHAR = 0
	    Do 455 I = 1, NC
		If (JLINE(I:I) .ne. ' ') Then
		    NCHAR = NCHAR + 1
		    LINE(NCHAR:NCHAR) = JLINE(I:I)
		    Endif
455		Continue

c	Remove trailing zeroes after decimal point

	    IND = Index (LINE(1:NCHAR),'D') - 1
	    If (IND .le. 0) IND = Index (LINE(1:NCHAR),'d') - 1
	    If (IND .le. 0) IND = Index (LINE(1:NCHAR),'E') - 1
	    If (IND .le. 0) IND = Index (LINE(1:NCHAR),'e') - 1
	    If (IND .le. 0) IND = NCHAR + 1
	    INP = Index (LINE(1:NCHAR),'.') + 1
	    If (INP .gt. 1) Then
		NZ = 0
		Do 456 IC = IND-1, INP, -1
		    If (LINE(IC:IC) .ne. '0') Go to 457
456		    NZ = NZ + 1
		IC = INP + 1
457	 	If (NZ .gt. 0) Then
		    NC = NCHAR + 1
		    NCHAR = NCHAR - NZ
		    LINE(IND-NZ:NCHAR+1) = LINE(IND:NC)
		    Endif
		Endif

c  Integer

	Elseif (ITYPE .lt. -10) Then

c	Integer*1

	   If (ITYPE .eq. -11) Then
	      NC = 4
	      CVAL(2) = NULL
	      Write(JLINE,461) JVAL(1)
461	      Format(I4)

c	Integer*2

	   Elseif (ITYPE .eq. -12) Then
	      NC = 6
	      Write(JLINE,462) JVAL(1)
462	      Format(I6)

c	Integer*4

	   Else
	      NC = 12
	      Write(JLINE,463) KVAL
463	      Format(I12)
	   Endif

c	Remove leading blanks; ignore trailing blanks

	    NCHAR = 0
	    Do 465 IC = 1, NC
		JCHR = JLINE(IC:IC)
		If (JCHR .ne. ' ') Then
		    NCHAR = NCHAR + 1
		    LINE(NCHAR:NCHAR) = JCHR
		    Endif
465		Continue

c  Any other data type

	Else
	   Call PNEWLINE
	   Write(JLINE,475) ITYPE
475	   Format('BINASC: Illegal data type',I4,'$')
	   Call PSTRING (JLINE)
	   IER = 1
	Endif

c  Return to calling program

	Call PADNULL (LINE)
	Return
	End

c--- BINASCL translates Logical to string

	Subroutine BINASCL (IVAL,STRING)

	Logical IVAL
c				Input value
	Character*(*) STRING
c				Character string (returned)


	If (IVAL) Then
	    STRING = 'Y'
	Else
	    STRING = 'N'
	Endif
	Call PADNULL (STRING)

	Return
	End



c--- BINASCI4 translates Integer*4 to string

	Subroutine BINASCI4 (IVAL,STRING)

	Integer*4 IVAL
c				Input value
	Character*(*) STRING
c				Character string (returned)

	Integer*4 NCHAR,NCS,IC
	Character*16 JLINE
	Character*1 JCHR

c  Zero out character string to be returned

	Call ZSTRING (STRING)

c  Write to string

	Write(JLINE,10) IVAL
10	Format(I12)

c  Remove leading blanks; ignore trailing blanks

	NCS = Len (STRING)
	NCHAR = 0
	Do 20 IC = 1, 12
	    JCHR = JLINE(IC:IC)
	    If (JCHR .ne. ' ') Then
		NCHAR = NCHAR + 1
		If (NCHAR .le. NCS) Then
		    STRING(NCHAR:NCHAR) = JCHR
		    Endif
		Endif
20	    Continue

	Return
	End

c--- BINASCI2 translates Integer*2 to string

	Subroutine BINASCI2 (IVAL,STRING)

	Integer*2 IVAL
c				Input value
	Character*(*) STRING
c				Character string (returned)

	Integer*4 NCHAR,NCS,IC
	Character*16 JLINE
	Character*1 JCHR

c  Zero out character string to be returned

	Call ZSTRING (STRING)

c  Write to string

	Write(JLINE,10) IVAL
10	Format(I6)

c  Remove leading blanks; ignore trailing blanks

	NCS = Len (STRING)
	NCHAR = 0
	Do 20 IC = 1, 6
	    JCHR = JLINE(IC:IC)
	    If (JCHR .ne. ' ') Then
		NCHAR = NCHAR + 1
		If (NCHAR .le. NCS) Then
		    STRING(NCHAR:NCHAR) = JCHR
		    Endif
		Endif
20	    Continue

	Return
	End

c--- BINASCR4 translates Real*4 to string

	Subroutine BINASCR4 (RVAL,STRING)

	Real*4 RVAL
c				Input value
	Character*(*) STRING
c				Character string (returned)

	Integer*4 LRVAL,NC,NDEC,NZ,IC,IND,INP,I,NCHAR
	Character*32 JLINE
	Character*8 FORM

c  Zero out character string to be returned

	Call ZSTRING (STRING)

	If (RVAL .eq. 0) Then
	    LRVAL = 0
	Else
	    LRVAL = Nint (Alog10 (Abs (RVAL)))
	Endif
	If ((LRVAL .lt. 7) .and. (LRVAL .gt. -2)) Then
	    NC = 9
	    NDEC = 6 - LRVAL
	    If (LRVAL .lt. 0) NC = NDEC + 2
	    Write(FORM,10) NC,NDEC
10	    Format('(F',I1,'.',I1,')')
	    Write(JLINE,FORM) RVAL
	Elseif ((LRVAL .lt. -1) .and. (LRVAL .gt. -7)) Then
	    NDEC = 3 - LRVAL
	    NC = NDEC + 2
	    Write(FORM,12) NC,NDEC
12	    Format('(F',I2,'.',I1,')')
	    Write(JLINE,FORM) RVAL
	Elseif ((LRVAL .lt. -6) .and. (LRVAL .gt. -10)) Then
	    NDEC = -LRVAL + 3
	    NC = NDEC + 2
	    Write(FORM,14) NC,NDEC
14	    Format('(F',I2,'.',I2,')')
	    Write(JLINE,FORM) RVAL
	Else
	    NC = 14
	    Write(JLINE,15) RVAL
15	    Format(G14.7)
	Endif

c  Remove leading blanks; ignore trailing blanks

	NCHAR = 0
	Do 20 I = 1, NC
	    If (JLINE(I:I) .ne. ' ') Then
		NCHAR = NCHAR + 1
		STRING(NCHAR:NCHAR) = JLINE(I:I)
		Endif
20	    Continue

c  Remove trailing zeroes after decimal point

	IND = Index (STRING(1:NCHAR),'D') - 1
	If (IND .le. 0) IND = Index (STRING(1:NCHAR),'d') - 1
	If (IND .le. 0) IND = Index (STRING(1:NCHAR),'E') - 1
	If (IND .le. 0) IND = Index (STRING(1:NCHAR),'e') - 1
	If (IND .le. 0) IND = NCHAR + 1
	INP = Index (STRING(1:NCHAR),'.') + 1
	If (INP .gt. 1) Then
	    NZ = 0
	    Do 30 IC = IND-1, INP, -1
		If (STRING(IC:IC) .ne. '0') Go to 35
30		NZ = NZ + 1
	    IC = INP + 1
35	    If (NZ .gt. 0) Then
		NC = NCHAR + 1
		NCHAR = NCHAR - NZ
		STRING(IND-NZ:NCHAR+1) = STRING(IND:NC)
		Endif
	    Endif

	Return
	End


c--- BINASCR8 translates Real*8 to string

	Subroutine BINASCR8 (DVAL,STRING)

	Real*8 DVAL
c				Input value
	Character*(*) STRING
c				Character string (returned)

	Integer*4 LDVAL,NC,NDEC,NZ,IC,IND,INP,I,NCHAR
	Character*32 JLINE
	Character*8 FORM

c  Zero out character string to be returned

	Call ZSTRING (STRING)

	If (DVAL .eq. 0.) Then
	    LDVAL = 0
	Else
	    LDVAL = Idnint (Dlog10 (Dabs (DVAL)))
	Endif
	If ((LDVAL .lt. 16) .and. (LDVAL .gt. -10)) Then
	    NC = 19
	    NDEC = 16 - LDVAL
	    If (NDEC .gt. 15) NDEC = 15
	    If (NDEC .lt. 10) Then
		Write(FORM,10) NC,NDEC
10		Format('(F',I2,'.',I1,')')
	    Else
		Write(FORM,11) NC,NDEC
11		Format('(F',I2,'.',I2,')')
	    Endif
	    Write(JLINE,FORM) DVAL
	Else
	    NC = 23
	    Write(JLINE,12) DVAL
12	    Format(G23.16)
	Endif

c  Remove leading blanks; ignore trailing blanks

	NCHAR = 0
	Do 20 I = 1, NC
	    If (JLINE(I:I) .ne. ' ') Then
		NCHAR = NCHAR + 1
		STRING(NCHAR:NCHAR) = JLINE(I:I)
		Endif
20	    Continue

c  Remove trailing zeroes after decimal point

	IND = Index (STRING(1:NCHAR),'D') - 1
	If (IND .le. 0) IND = Index (STRING(1:NCHAR),'d') - 1
	If (IND .le. 0) IND = Index (STRING(1:NCHAR),'E') - 1
	If (IND .le. 0) IND = Index (STRING(1:NCHAR),'e') - 1
	If (IND .le. 0) IND = NCHAR + 1
	INP = Index (STRING(1:NCHAR),'.') + 1
	If (INP .gt. 1) Then
	    NZ = 0
	    Do 30 IC = IND-1, INP, -1
		If (STRING(IC:IC) .ne. '0') Go to 35
30		NZ = NZ + 1
	    IC = INP + 1
35	    If (NZ .gt. 0) Then
		NC = NCHAR + 1
		NCHAR = NCHAR - NZ
		STRING(IND-NZ:NCHAR+1) = STRING(IND:NC)
		Endif
	    Endif

	Return
	End


c--- BINASNR8 translates Real*8 to string

	Subroutine BINASNR8 (DVAL, NDEC, STRING)

	Real*8 DVAL
c				Input value
	Integer*4 NDEC
c				Number of decimal places in output string
	Character*(*) STRING
c				Character string (returned)

	Character*16 FORM
c				Format for output
	Integer*4 NFIELD, NC, I, NF, NB

	NFIELD = 23
	NC = Len (STRING)
	If (NC .lt. NFIELD) NFIELD = NC

	If (NDEC .lt. 10) Then
	    Write(FORM,10) NDEC
10	    Format('(F23.',I1,')')
	Else
	    Write(FORM,15) NDEC
15	    Format('(F.23',I2,')')
	Endif

	Write(STRING,FORM) DVAL
	Call PADNULL (STRING)

c  Remove leading spaces
	NB = 0
	Do I = 1, NFIELD
	    If (STRING(I:I) .eq. ' ') Then
		NB = NB + 1
	    Else
		Go to 20
	    Endif
	    Enddo

20	If (NB .gt. 0) Then
	    NF = NFIELD - NB
	    Do I = 1, NF
		STRING(I:I) = STRING(I+NB:I+NB)
		Enddo
	    Do I = NF+1, NFIELD
		STRING(I:I) = Char (0)
		Enddo
	    Endif

	Return
	End

c Jun 25 1985	Fix length of null-terminated strings

c Feb  7 1986	Use PCHRS instead of PCHAR
c Jul 15 1986	Find terminating NULL with Index

c Mar 13 1987	Fix length of strings and logicals
c Jun 18 1987	Remove extra zeroes after decimal point
c Dec  8 1987	Pad ASCII value with NULLs
c Dec 11 1987	Clean up code; fix trailing zeroes bug

c Mar 14 1989	Clean up code for RISC machine

c May 25 1990	Add separate subroutines for each numeric data type
c Aug 27 1990	Avoid exponents unless absolutely necessary
c Sep 28 1990	Fix floating point formats

c Feb 25 1992	Fix Real*4 format
c Sep  9 1992	Add Logical format
c Oct 16 1992	Declare undeclared variables
c Sep 15 1993	Zero-fill strings before filling them

c Jan 13 1995	Drop unused variables
c Oct 11 1995	Allow more decimal places in a real*4 number

c May  7 1998	Add BINASNR8
c Aug 20 1998	Declare undeclared variables
