c*** File iolib/conset.f
c*** December 4, 1992
c*** By Doug Mink

	Subroutine CONSET

c--- Set constants for astronomical work

	Include 'constants.cmb'

c  Speed of light in km sec-1

	C = 2.99792458d+5

c  Gravitational constant in km^3 s-2 g-1

	GR = 6.67d-23

c  Ellipticity of the earth (AE&NA)

	E = .081820d0
	E2 = E * E

c  Equatorial radius of the earth in km (IAU 1976)

	RE = 6378.140d0

c  Degrees to radians

	RCON = 1.74532925199433d-2

c  PI, 2 * PI, PI / 2

	PI = 180.d0 * RCON
	TPI = 360.d0 * RCON
	PI2 = 90.d0 * RCON

c  Kilometers per Astronomical Unit (JPL DE-130)

	ACON = 149597870.6094335297d0

c  Names of the months of the year

	DMON(1) = 'Jan '
	DMON(2) = 'Feb '
	DMON(3) = 'Mar '
	DMON(4) = 'Apr '
	DMON(5) = 'May '
	DMON(6) = 'Jun '
	DMON(7) = 'Jul '
	DMON(8) = 'Aug '
	DMON(9) = 'Sep '
	DMON(10) = 'Oct '
	DMON(11) = 'Nov '
	DMON(12) = 'Dec '

	Return
	End

c Dec  4 1992	Change RE from 6378.16 to 6378.14 to match 1976 IAU
c		Change ACON from DE-96 149597871.4105583d0 to DE-130 value
