/* File iolib/dirtemp.c
 * February 9, 1999
 * By Doug Mink. Center for Astrophysics
 */

#include <sys/types.h>
#include <dirent.h>
#include <string.h>
#include <stdio.h>

dirtemp_ (dirname, template, ntemp, filename,ncd, nct, ncf)

/*   Match pattern in directory (Fortran-callable)
 *
 *	Call DIRTEMP (DIRNAME,TEMPLATE,NTEMP,FILENAME) from Fortran
 *
 *	Character*(*) DIRNAME
 *			Address of null-terminated directory path name
 *	Character*(*) TEMPLATE
 *			Address of null-terminated template string
 *	Integer*4 NTEMP
 *			Number of characters to match in TEMPLATE
 *	Character*(*) FILENAME
 *			Address of null-terminated file name (returned)
 *
 *	ncd	Number of characters in string DIRNAME
 *	nct	Number of characters in string TEMPLATE
 *	ncf	Number of characters in string FILENAME
 *		* these are not explicitly in the calling argument list;
 *		* Fortran puts them there
 */

char *dirname;
char *template;
char *filename;
long *ntemp;
int ncd,nct,ncf;

{
DIR *dirp;
struct dirent *dp;
int nt;

	*filename = 0;
	nt = *ntemp;

	dirp = NULL;
	dirp = opendir (dirname);
	if (dirp == NULL) {
	    printf ("DIRTEMP:  Directory '%s' not found\n",dirname);
	    return;
	    }
	for (dp = readdir (dirp); dp != NULL; dp = readdir (dirp))
	    if (!strncmp (dp->d_name, template, nt)) {
		strcpy (filename,dp->d_name);
		break;
		}
	closedir (dirp);
	return;
}
/* Aug 12 1991	New subroutine
 *
 * Feb  9 1999	Moved from tdclib to iolib
 */
