c*** File iolib/entpar.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine ENTPAR (HSTRING,PROMPT,ITYPE,VNAME)

c  Get current value of parameter VNAME from parameter string HSTRING,
c  receive new value from keyboard using PROMPT and
c  enter "<VNAME> = <IVAL>" into parameter string HSTRING.
c  Default values are 0 for numbers and Char(0) for character strings

	Character*(*) HSTRING
c		Character string containing FITS-style header information
c		in the format <VNAME>= <value> {/ <comment>}
c		Unlike FITS, however, lines may be of arbitrary length
c		terminated by nulls, carriage returns or linefeeds,
c		although FITS' 80-column format is supported, too.

	Character*(*) PROMPT
c		string printed to prompt input
c		If not null, it must be terminated by a $ (dollar sign)
c		For command, '? ' is added.
c		For single character, ' : ' is added.
c		Otherwise, ' = ' is added and a CR terminates entry.

	Integer*4 ITYPE
c		Data type
c		  first ':' or ' ' treated as '.', later ':'s and '.'s ignored.
c		  illegal characters, overflows, and underflows trapped. 
c		-1n: Integer n bytes long (Integer*n)
c		-2n: Floating point number n bytes long (Real*n)
c		-3n: Logical variable n bytes long (Logical*n) (t or f)
c		-4n: Logical variable n bytes long (Logical*n) (y or n)
c		1-99: Length of Character string returned, padded with spaces
c		101-199: Length (+100) of Character string returned
c			padded with nulls
c		201-236: number (+200) of single characters
c			returned in array of 36 (A-Z,0-9) Integer*2
c			with array positions corresponding to letter
c			or number entered set to one.  Array is not
c			zeroed on entry.
c			Lower case letters are treated as upper case.
c		301-399: Length (+300) of Character string returned
c			padded with nulls
c			Lower case letters are converted to upper case.

	Character*(*) VNAME
c		Character string containing the name of the variable
c		to be returned.  EXTRACT searches for a line beginning
c		with this string.
c		IMPORTANT:  Because of the definition of Fortran 77
c		            character strings, this must be terminated
c		            by a '$'.

	Integer*4 IVAL(2)
c		Address for returned number
	Character*120 CVAL,CTEMP
c		Address for returned character string
	Character*1 NULL
	Integer LCT

	Include 'header.cmb'

	If (ITYPE .ge. -1) Then
	    NULL = Char (0)
	    CTEMP(1:1) = NULL
	    Call PGETC (HSTRING,VNAME,CTEMP)
	    Call ENTERC (PROMPT,ITYPE,CTEMP)
	    Call VLEN (CTEMP,LCT)
	    CVAL(1:1) = Char (39)
	    CVAL(2:LCT+1) = CTEMP(1:LCT)
	    CVAL(LCT+2:LCT+2) = Char (39)
	    CVAL(LCT+3:LCT+3) = NULL
	    Call PPUTC (HSTRING,VNAME,CVAL)
	Else
	    IVAL(1) = 0
	    IVAL(2) = 0
	    Call PGET (HSTRING,VNAME,ITYPE,IVAL)
	    Call ENTER (PROMPT,ITYPE,IVAL)
	    Call PPUT (HSTRING,VNAME,ITYPE,IVAL)
	Endif

	Return
	End

c Jun 22 1987	Use PGET and PPUT instead of EXTRACT and IMPLANT
c Jun 25 1987	Always put quotes around character strings

c Feb 22 1993	Declare undeclared variable lct
