c*** File iolib/erase.f
c*** February 22, 1993
c*** By Doug Mink

	Subroutine ERASE

c--- Clear terminal display

	Character IESC*1,ICTL*1,IUS*1,COMSEQ*10
	Integer*4 IFIP,IOPT

	Include 'term.cmb'

	Common/PLF/ IFIP,IOPT

	Call GETTERM

	If (TTERM(1:1) .eq. Char (0)) Call GETTERM
	IESC = Char (27)
	ICTL = Char (12)
	IUS = Char (31)

c  Erase terminal when in vt52 mode
c    See VT240 Series Programmer Reference Manual p.4-60
c    Send ESC H to home cursor, then send ESC J to clear to end of screen

	If (TTERM .eq. 'vt52') Then
	   COMSEQ(1:1) = IESC
	   COMSEQ(2:2) = 'H'
	   COMSEQ(3:3) = IESC
	   COMSEQ(4:4) = 'J'
	   Call PCHRT (4,COMSEQ)

c  Erase terminal when in vt100 or vt220 mode
c    See VT240 Series Programmer Reference Manual p.4-28 and p.4-34.
c    Send ESC [ ; H to home cursor, then send ESC [ 2 J to clear screen.

	Elseif ((TTERM.eq.'vt100') .or. (TTERM.eq.'vt220')) Then
	   COMSEQ(1:1) = IESC
	   COMSEQ(2:4) = '[;H'
	   COMSEQ(5:5) = IESC
	   COMSEQ(6:8) = '[2J'
	   Call PCHRT (8,COMSEQ)

c  Erase terminal when in vt240 mode (same as above)

	Elseif ((TTERM .eq. 'vt240') .and. (.not. ITEK)) Then
	   COMSEQ(1:1) = IESC
	   COMSEQ(2:4) = '[;H'
	   COMSEQ(5:5) = IESC
	   COMSEQ(6:8) = '[2J'
	   Call PCHRT (8,COMSEQ)

c  Erase terminal when in Tektronix mode

	Elseif ((TTERM.eq.'vt240') .or. (TTERM(1:3).eq.'aed')) Then
	   COMSEQ(1:1) = IESC
	   COMSEQ(2:2) = ICTL
	   COMSEQ(3:3) = IUS
	   Call PCHRT (3,COMSEQ)

c  Erase terminal when in Tektronix mode

	Elseif ((TTERM(1:3).eq.'tek') .or. (TTERM(1:6).eq.'vs100t')) Then
	   COMSEQ(1:1) = IESC
	   COMSEQ(2:2) = ICTL
	   COMSEQ(3:3) = IUS
	   Call PCHRT (3,COMSEQ)

c  Erase Vs100

	Elseif ((TTERM.eq.'vs100') .or. (TTERM .eq. 'xterm')) Then
	   COMSEQ(1:1) = IESC
	   COMSEQ(2:4) = '[;H'
	   COMSEQ(5:5) = IESC
	   COMSEQ(6:8) = '[2J'
	   Call PCHRT (8,COMSEQ)

	Else
	   Call SHELL ('clear')

	Endif

c  Send tektronix erase to disk file if logging

	If (IFIP .gt. 2) Then
	    COMSEQ(1:1) = IESC
	    COMSEQ(2:2) = ICTL
	    COMSEQ(3:3) = IUS
	    Call PCHRF (3,COMSEQ)
	    Endif

	Return
	End

c Aug 3 1984	Call GETTERM to get terminal type, now that it's no longer
c		a System call.
c Sep 27 1984	Call GETTERM only if TTERM is not set yet.
c Oct 24 1984	Use Tektronix erase for any AED terminal
c Oct 26 1984	Add vs100 and Tektronix terminals explicitly
c Dec 21 1984	Send different erase commands to log file and terminal
c		(Always send Tektronix ESC FF IUS to file)

c Jul 10 1985	Add xterm (new Vs100 and QVSS terminal emulator)

c Apr 27 1988	Call GETTERM to get termianl type

c Oct  5 1990	Call SHELL instead of System

c Feb 22 1993	Declare undeclared variables ifip and iopt
