c*** File iolib/median.f
c*** March 27, 1995
c*** from Press, et al. Quicksort

	Subroutine MEDIANR4 (X, N, XMED,XM1,XM2)

	Integer*4 N
c			Size of vector
	Real*4 X(N)
c			Vector of numbers of which median is to be found
	Real*4 XMED
c			Median (returned)
	Real*4 XM1,XM2
c			Quartile points (returned)

	Real*4 XX
	Integer*4 L,IR,I,J,N2,N14,N34

	If (N .le. 0) Then
	    XMED = 0.
	    Return
	Elseif (N .eq. 1) Then
	    XMED = X(1)
	    Return
	Endif

	L = N / 2 + 1
	IR = N

10	Continue
	If (L .gt. 1) Then
	    L = L - 1
	    XX = X(L)
	Else
	    XX = X(IR)
	    X(IR) = X(1)
	    IR = IR - 1
	    If (IR .eq. 1) Then
		X(1) = XX
		N2 = N / 2
		If (Mod (N, 2) .eq. 0) Then
		    XMED = 0.5 * (X(N2) + X(N2+1))
		Else
		    XMED = X(N2+1)
		Endif
		N14 = Nint (N * 0.25 + 0.5)
		N34 = Nint (N * 0.75 + 0.5)
		XM1 = X(N14)
		XM2 = X(N34)
		Return
		Endif
	Endif
	I = L
	J = L + L

20	If (J .le. IR) Then
	    If (J .lt. IR) Then
		If (X(J) .lt. X(J+1)) J = J + 1
		Endif
	    If (XX .lt. X(J)) Then
		X(I) = X(J)
		I = J
		J = J + J
	    Else
		J = IR + 1
	    Endif
	    Go to 20
	    Endif
	X(I) = XX
	Go to 10
	End


	Subroutine MEDIANR8 (X, N, XMED,XM1,XM2)

	Integer*4 N
c			Size of vector
	Real*8 X(N)
c			Vector of numbers of which median is to be found
	Real*8 XMED
c			Median (returned)
	Real*8 XM1,XM2
c			Quartile points (returned)

	Real*8 XX
	Integer*4 L,IR,I,J,N2,N14,N34

	If (N .le. 0) Then
	    XMED = 0.
	    Return
	Elseif (N .eq. 1) Then
	    XMED = X(1)
	    Return
	Endif

	L = N / 2 + 1
	IR = N

10	Continue
	If (L .gt. 1) Then
	    L = L - 1
	    XX = X(L)
	Else
	    XX = X(IR)
	    X(IR) = X(1)
	    IR = IR - 1
	    If (IR .eq. 1) Then
		X(1) = XX
		N2 = N / 2
		If (Mod (N, 2) .eq. 0) Then
		    XMED = 0.5 * (X(N2) + X(N2+1))
		Else
		    XMED = X(N2+1)
		Endif
		N14 = Nint (N * 0.25 + 0.5)
		N34 = Nint (N * 0.75 + 0.5)
		XM1 = X(N14)
		XM2 = X(N34)
		Return
		Endif
	Endif
	I = L
	J = L + L

20	If (J .le. IR) Then
	    If (J .lt. IR) Then
		If (X(J) .lt. X(J+1)) J = J + 1
		Endif
	    If (XX .lt. X(J)) Then
		X(I) = X(J)
		I = J
		J = J + J
	    Else
		J = IR + 1
	    Endif
	    Go to 20
	    Endif
	X(I) = XX
	Go to 10
	End


	Subroutine MEDIANI4 (X, N, XMED,XM1,XM2)

	Integer*4 N
c			Size of vector
	Integer*4 X(N)
c			Vector of numbers of which median is to be found
	Integer*4 XMED
c			Median (returned)
	Integer*4 XM1,XM2
c			Quartile points (returned)

	Integer*4 XX
	Integer*4 L,IR,I,J,N2,N14,N34

	If (N .le. 0) Then
	    XMED = 0.
	    Return
	Elseif (N .eq. 1) Then
	    XMED = X(1)
	    Return
	Endif

	L = N / 2 + 1
	IR = N

10	Continue
	If (L .gt. 1) Then
	    L = L - 1
	    XX = X(L)
	Else
	    XX = X(IR)
	    X(IR) = X(1)
	    IR = IR - 1
	    If (IR .eq. 1) Then
		X(1) = XX
		N2 = N / 2
		If (Mod (N, 2) .eq. 0) Then
		    XMED = Nint (0.5 * (X(N2) + X(N2+1)))
		Else
		    XMED = X(N2+1)
		Endif
		N14 = Nint (N * 0.25 + 0.5)
		N34 = Nint (N * 0.75 + 0.5)
		XM1 = X(N14)
		XM2 = X(N34)
		Return
		Endif
	Endif
	I = L
	J = L + L

20	If (J .le. IR) Then
	    If (J .lt. IR) Then
		If (X(J) .lt. X(J+1)) J = J + 1
		Endif
	    If (XX .lt. X(J)) Then
		X(I) = X(J)
		I = J
		J = J + J
	    Else
		J = IR + 1
	    Endif
	    Go to 20
	    Endif
	X(I) = XX
	Go to 10
	End

c Mar 27 1995	Add quarter points to return
