c*** File iolib/openr.f
c*** February 22, 1993
c*** Doug Mink and Dick French

	Subroutine OPENR (IDEV, FNAME)

c--- Open a file for reading

	Integer*4 IDEV
c			UNIX file descriptor (returned)
c			If =-2 on entry, there will be no printed error
c			messages, and IDEV will be unchanged on return.
	Character*(*) FNAME
c			Null-terminated file pathname
c			If error condition arises and IDEV is not =-2, this
c			subroutine will request a new file name from the user.

	Character FNAME0*64
	Integer*4 I, IDEV0, IER, LFN

c  Find length of file name and pad with nulls

	Call PADNULL (FNAME)

c  Check for existence of file

10	Call SSEXST (FNAME,IER)

c  If file exists, check for read permission

	If (IER .eq. 0) then
	   Call SSREAD (FNAME,IER)
	   If (IER .eq. -1) Then
	      Call ESET
	      If (IDEV .gt. -2) Write(*,20) FNAME
20	      Format('*** OPENR: File "',A,'" is read-protected')

c  If file is read-accessible, open it

	   Else
	      Call SOPEN (IDEV0,0,FNAME)
	      If (IDEV0 .eq. -1) Then
	         Call ESET
	         If (IDEV .gt. -2) Write(*,30) FNAME
30	         Format('*** OPENR: File "',A,'" cannot be opened')
	      Else
	         IDEV = IDEV0
	         Return
	      Endif
	   Endif

c  If file does not exist, print error message.

	Else
	   Call ESET
	   If (IDEV .gt. -2) Write(*,40) FNAME
40	   Format('*** OPENR: File "',A,'" does not exist')
	Endif

c  If IDEV=-2 on entry, bail out; otherwise, prompt user for
c  new file name and try again.

	If (IDEV .eq. -2) Return

	Call ENTERC ('Enter new file name (0>none)$',164,FNAME0)
	Call ESET
	LFN = Len (FNAME)
	If ((FNAME0(1:1) .eq. '0') .or. (LFN .le. 0)) Return
	Do 105 I = 1, LFN
105	   FNAME(I:I) = FNAME0(I:I)
	Go to 10
	End

c Aug 4, 1984	Changed to avoid use of argument FNAME0 after assignment
c		to FNAME; this eliminates the possibility of inadvertent
c		overwriting of a literal pathname or writing beyond the
c		storage reserved by the variable passed in the Call.
c Aug 17 1984	Change back to overwrite FNAME0 if error and new file input
c		Transfer characters of pathname one at a time
c Aug 20 1984	Fill out FNAME0 with nulls if overwritten.
c Nov  5 1984	Increase maximum pathname length to 50

c Feb 26 1985	Print formatted rather than unformatted error messages
c		Clean up logic
c Jun 21 1985	Use Character filenames in SSx calls
c Aug 23 1985	If IDEV is -2 or less, don't print error messages

c Jan 22 1988	Replace PADSTR call with PADNULL

c Feb 22 1993	Declare undeclared variables i, idev0, ier, and lfn
