c*** File iolib/openrf.f
c*** February 22, 1993
c*** Dick French and Doug Mink

	Subroutine OPENRF (IDEV, FNAME)

c--- Open a Fortran 77 file for reading

	Integer*4 IDEV
c			Fortran 77 unit number
	Character*(*) FNAME
c			File pathname
c			If an error condition arises, this subroutine
c			will request a new file name from the user.

	Character FNAME0*64
	Integer*4 I, IER, IOS, LFN

c  Find length of file name and pad with nulls

	Call PADNULL (FNAME)

c Check for existence of file

10	Call SSEXST (FNAME,IER)

c  If file exists,  check for read permission and see if it's an executable 
c  file.  If read-protected, print error message and prompt user for new
c  file name and try again.

	If (IER .eq. 0) then
	   Call SSREAD (FNAME,IER)
	   If (IER .eq. -1) Then
	      Call ESET
	      Write(*,15) FNAME
15	      Format('*** OPENRF: File "',A,'" is read-protected')
	      If (IDEV .eq. -2) Then
	         Return
	      Else
	         Go to 100
	      Endif
	   Else
	      Open (File=FNAME, Unit=IDEV,ERR=20,Iostat=IOS,Status='UNKNOWN')
	      Return

20	      Call ESET
	      Write(*,25) FNAME
25	      Format('*** OPENRF: File "',A,'" cannot be opened')
	      Write(*,*) '            Error code =',IOS
	      Go to 100
	   Endif

c  If file does not exist, print error message and prompt user for
c  new file name and try again.

	Else
	   Call ESET
	   Write(*,35) FNAME
35	   Format('*** OPENRF: File "',A,'" does not exist')
	   Go to 100
	Endif

c  Enter new file name

100	Call ENTERC ('Enter new file name (0>none)$',164,FNAME0)
	Call ESET
	LFN = Len (FNAME)
	If ((FNAME0(1:1) .eq. '0') .or. (LFN .le. 0)) Return
	Do 105 I = 1, LFN
105	   FNAME(I:I) = FNAME0(I:I)
	Go to 10
	End

c Nov 6 1984	Allow up to 50 characters in pathname

c Jun 21 1985	Use Character filenames in SSx calls
c		Allow up to 64 characters in file name, if replaced

c Jan 22 1988	Replace PADSTR call with PADNULL

c Jul 11 1991	Set STATUS='UNKNOWN' and eliminate unnecessary Return

c Feb 22 1993	Declare undeclared variables i, ier, ios, and lfn
