c*** File iolib/openw.f
c*** May 27, 1993
c*** By Doug Mink and Dick French

	Subroutine OPENW (IDEV, FNAME)

c--- Open file for writing

	Integer*4 IDEV
c			UNIX file descriptor (returned)
c			If =-2 on entry, there will be no printed error
c			messages, and IDEV will be unchanged on return.
	Character*(*) FNAME
c			File pathname
c			If error condition arises and IDEV is not =-2, this
c			subroutine will request a new file name from the user.

	Character FNAME0*64
	Integer*4 I, IDEV0, IER, LFN

c  Find length of file name and pad with nulls

	Call PADNULL (FNAME)

c  Check for existence of file

10	Call SSEXST (FNAME,IER)

c  If file exists,  check for write permission

	If (IER .eq. 0) then
	   Call SSWRIT (FNAME,IER)
	   If (IER .eq. -1) Then
	      Call ESET
	      If (IDEV .gt. -2) Write(*,20) FNAME
20	      Format('OPENW: File "',A,'" is write-protected')

c  If writing is permitted, see if it's an executable file.

	    Else
		Call SSEXEC (FNAME,IER)
		If (IER .eq. 0) Then
		    Call ESET
		    If (IDEV .gt. -2) Write(*,30) FNAME
30		    Format('OPENW: File "',A,'" is executable')
		    Endif

c  If file exists and can be written into, open it

		Call SOPEN (IDEV0,1,FNAME)
		If (IDEV0 .eq. -1) Then
		    Call ESET
		    If (IDEV .gt. -2) Write(*,40) FNAME
40		    Format('OPENW: File "',A,'" cannot be opened')
		Else
		    IDEV = IDEV0
		    Return
		Endif
	    Endif

c  If file does not exist, create it.

	Else
	   Call SOPEN (IDEV0,2,FNAME)
	   If(IDEV0.eq.-1) then
	      Call ESET
	      If (IDEV .gt. -2) Write(*,50) FNAME
50	      Format('OPENW: File "',A,'" not found; not creatable')
	   Else
	      IDEV=IDEV0
	      Return
	   Endif
	Endif

c  If IDEV=-2 on entry, bail out; otherwise, prompt user for
c  new file name and try again.

	If (IDEV .eq. -2) Return

	Call ENTERC ('Enter new file name (0>none)$',164,FNAME0)
	Call ESET
	LFN = Len (FNAME)
	If ((FNAME0(1:1) .eq. '0') .or. (LFN .le. 0)) Return
	Do 105 I = 1, LFN
105	   FNAME(I:I) = FNAME0(I:I)
	Go to 10
	End

c Aug 4, 1984	Revised to avoid changing calling argument FNAME0
c Aug 17 1984	Rerevise to change FNAME0 if error (optionally)
c		Transfer characters between pathnames one at a time
c Aug 20 1984	Fill out FNAME0 with nulls if overwritten

c Feb 26 1985	Clean up logic
c		Write formatted error messages rather than unformatted
c		Allow up to 64-character path names
c Jun 21 1985	Use Character filenames in SSx and SOPEN calls
c Aug 23 1985	Don't print any error messages if IDEV is -2 or less.

c Jan 22 1988	Replace PADSTR call with PADNULL

c Feb 22 1993	Declare undeclared variables i, idev0, ier, and lfn
c May 27 1993	Allow writing into executable file if write-enabled
