c*** File iolib/parinit.f
c*** February 22, 1993
c*** By Doug Mink, Center for Astrophysics

c--- Read parameter string from appropriate parameter file

	Subroutine PARINIT (PARMFILE,PARMS,DEFDIR,NR)

	Character*(*) PARMS
c				String containing parameter assignments
	Character*(*) PARMFILE
c				Parameter file name
	Character DEFDIR*(*)
c				Path name for default parameter directory
	Integer*4 NR
c				Number of bytes in parameter string

	Logical DIAG
	Integer*4 IARG,NARG,LPARM,IER,Iargc
	Character*20 SWITCH
	Character*64 DEFPATH
	External Iargc

c  Set name of parameter file to first argument or default

	NARG = Iargc ()
	IER = -1
	Call PADNULL (PARMFILE)

c  Search for -def default file override or -par parameter file override

	Do 100 IARG = 1, NARG
	    Call Getarg (IARG,SWITCH)
	    If (SWITCH(1:4) .eq. '-par') Then
		Call Getarg (IARG+1,PARMFILE)
		Call PADNULL (PARMFILE)
		Endif
	    If (SWITCH(1:4) .eq. '-def') Then
		Call Getarg (IARG+1,DEFDIR)
		Call PADNULL (DEFDIR)
		Endif
100	    Continue

c  If parameter file exists, read parameter string

	Call SSREAD (PARMFILE,IER)
	If (IER .ge. 0) Then
	    Call PREAD (PARMFILE,PARMS,NR)
	    Call PGETL (PARMS,'DIAG',DIAG)
	    If (DIAG) Then
		Call VLEN (PARMFILE,LPARM)
		Write(*,201) PARMFILE(1:LPARM)
201		Format('Parameters read from "',A,'"')
		Endif
	    Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	    Return
	    Endif

c  If PARMFILE is not found, read parameters from the default file

	Call MAKEPATH (DEFDIR,PARMFILE,DEFPATH)
	Call SSREAD (DEFPATH,IER)
	If (IER .ge. 0) Then
	    Call PREAD (DEFPATH,PARMS,NR)
	    Call VLEN (DEFPATH,LPARM)
	    Write(*,201) DEFPATH(1:LPARM)
	    Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	    Call PWRITE (PARMFILE,PARMS)
	    Return
	    Endif

c  If not found in DEFDIR, try directory from Unix environment DEFAULT_DIR

	Call Getenv ('DEFAULT_DIR',DEFDIR)
	Call PADNULL (DEFDIR)
	Call MAKEPATH (DEFDIR,PARMFILE,DEFPATH)
	Call SSREAD (DEFPATH,IER)
	If (IER .ge. 0) Then
	    Call PREAD (DEFPATH,PARMS,NR)
	    Call VLEN (DEFPATH,LPARM)
	    Write(*,201) DEFPATH(1:LPARM)
	    Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	    Call PWRITE (PARMFILE,PARMS)
	    Return
	    Endif

c  If default parameter file is not found, initialize parameter string

	Call PADNULL (PARMS)
	PARMS(1:3) = 'END'
	PARMS(4:4) = Char (10)
	Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	Return
	End

c Sep  8 1992	New subroutine
c Sep 24 1992	Drop ARG1--always use -par now
c Jan  5 1992	Always set length of parameter file name

c Feb 22 1993	Eliminate unused variable newfile
