c*** File iolib/parmget.f
c*** February 22, 1993
c*** By Doug Mink, Center for Astrophysics

c--- Read parameter string from appropriate parameter file

	Subroutine PARMGET (PARMFILE,PARMS,DEFPFILE,ARG1,NR)

	Character*(*) PARMS
c				String containing parameter assignments
	Character*(*) PARMFILE
c				Parameter file name
	Character DEFPFILE*(*)
c				Path name for default parmeter file
	Logical ARG1
c				If true, first argument is PARMFILE
	Integer*4 NR
c				Number of bytes in parameter string

	Logical DIAG
	Integer*4 NARG,LPARM,Iargc,IER,IARG
	Character*20 SWITCH
	Character*64 DEFDIR,DEFPATH,ARGUMENT

c  Set name of parameter file to first argument or default

	NARG = Iargc ()
	IER = -1
	Call PADNULL (PARMFILE)
	If ((ARG1) .and. (NARG .eq. 1)) Then
	    Call Getarg (1,ARGUMENT)
	    If ((ARGUMENT(1:1).ne.'-') .and. (Index(ARGUMENT,'=').eq.0)) Then
		PARMFILE = ARGUMENT
		Call PADNULL (PARMFILE)
		Endif

	Elseif (NARG .gt. 1) Then

c  Search for -def default file override or -par parameter file override

	    Do 100 IARG = 1, NARG
		Call Getarg (IARG,SWITCH)
		If (SWITCH(1:4) .eq. '-par') Then
		    Call Getarg (IARG+1,PARMFILE)
		    Call PADNULL (PARMFILE)
		    Endif
		If (SWITCH(1:4) .eq. '-def') Then
		    Call Getarg (IARG+1,DEFPFILE)
		    Call PADNULL (DEFPFILE)
		    Endif
100		Continue
	Endif

c  If parameter file exists, read parameter string

	Call SSREAD (PARMFILE,IER)
	If (IER .ge. 0) Then
	    Call PREAD (PARMFILE,PARMS,NR)
	    Call PGETL (PARMS,'DIAG',DIAG)
	    Call VLEN (PARMFILE,LPARM)
	    If (DIAG) Write(*,201) PARMFILE(1:LPARM)
201	    Format('Parameters read from "',A,'"')
	    Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	    Return
	    Endif

c  If PARMFILE is not found, read parameters from the default file

	Call SSREAD (DEFPFILE,IER)
	If (IER .ge. 0) Then
	    Call PREAD (DEFPFILE,PARMS,NR)
	    Call VLEN (DEFPFILE,LPARM)
	    Write(*,201) DEFPFILE(1:LPARM)
	    Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	    Call PWRITE (PARMFILE,PARMS)
	    Return
	    Endif

c  If DEFPFILE is not found, read parameters from the default directory

	Call Getenv ('DEFAULT_DIR',DEFDIR)
	Call PADNULL (DEFDIR)
	Call MAKEPATH (DEFDIR,PARMFILE,DEFPATH)
	Call SSREAD (DEFPATH,IER)
	If (IER .ge. 0) Then
	    Call PREAD (DEFPATH,PARMS,NR)
	    Call VLEN (DEFPATH,LPARM)
	    Write(*,201) DEFPATH(1:LPARM)
	    Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	    Call PWRITE (PARMFILE,PARMS)
	    Return
	    Endif

c  If default parameter file is not found, initialize parameter string

	Call PADNULL (PARMS)
	PARMS(1:3) = 'END'
	PARMS(4:4) = Char (10)
	Call PPUTS (PARMS,'PARMFILE',PARMFILE)
	Return
	End

c Aug 15 1990	Write local parameter file if default file is read
c Nov  7 1990	Read default from -def flagged directory

c Mar 29 1991	Add default directory from environment
c Sep 20 1991	Allow single argument switch or assignment if ARG1 is true

c Jul 27 1992	Print parameter file name only if getting default or DIAG=true
c Sep  2 1992	Write parameter file name into parameter string
c Oct 16 1992	Declare undeclared variables

c Feb 22 1993	Drop unused variable newfile
