c*** File iolib/pread.f
c*** February 22, 1993
c*** By Doug Mink

c--- Read FITS-like parameter file
c    Note settings of /HEADER/ common.

	Subroutine PREAD (FNAME,HSTRING,NR)

	Character*(*) FNAME
c				File name
	Character*(*) HSTRING
c				Header string (returned)
	Integer*4 NR
c				Number of characters actually read (returned)
c				Value of 0 returned if unsuccessful

	Integer*4 LSTR,N,IFIL,IEND,IER,LFN

	Include 'header.cmb'

c  Initialize header string to NULL

	LSTR = Len (HSTRING)
	Call ZFILLC (HSTRING,LSTR)

c  Open data file, returning if not found

	IFIL = -2
	NR = 0
	Call OPENR (IFIL,FNAME)
	If (IFIL .lt. 3) Then
	    Call VLEN (FNAME,LFN)
	    Write(*,40) FNAME(1:LFN)
40	    Format('PREAD:  No parameter file: "',A,'"')
	    NR = 0
	    HSTRING(1:3) = 'END'
	    HSTRING(4:4) = Char (10)
	    HSTRING(5:5) = Char (0)
	    Call PADNULL (HSTRING)
	    Return
	    Endif

c  Read FITS header

	Call SGETC (IFIL,LSTR,HSTRING,NR)
50	If (NR .lt. 2) Then
	    Call ESET
	    Write(*,60) NR,FNAME
60	    Format('PREAD:  No parameters,',I2,' bytes in file "',A,'"')
	    NR = 0
	    HSTRING(1:3) = 'END'
	    HSTRING(4:4) = Char (10)
	    HSTRING(5:5) = Char (0)
	    Call PADNULL (HSTRING)
	    Return
	    Endif

c  If END not found, print error message and/or initialize string

	Call PSEARCH (HSTRING,'END',IEND,N)
	If (IEND .le. 0) Then
	    Call ESET
	    Write(*,105) FNAME
105	    Format('PREAD: No header END in file "',A,'"')
	    NR = 0
	    Return
	    Endif

	If (VERBOSE) Then
	    Call ESET
	    Write(*,120) NR,FNAME
120	    Format('PREAD:',I5,'-byte header read from file "',A,'"')
	    Endif

	Call SCLOSE (IFIL,IER)

	Return
	End

c Jul  2 1987	Don't set PACKED; new PGET and PPUT routines don't need it
c Oct  6 1987	Initialize parameter string if no file or no string
c Dec 30 1987	Declare all variables

c Feb 22 1993	Declare undeclared variables iend, ier, and lfn
