c*** File iolib/parset.f
c*** June 9, 1998
c*** By Doug Mink

	Subroutine PSET (PARMS,CSTRING,LIST,ASSIGNED)

c    Read the <keyword> = <value> from character string CSTRING.
c    Search PARMS for <keyword> and if it's found, change its
c    value within PARMS.  If <keyword> is not found, make CSTRING
c    the last line in PARMS before END.  PARMS uses only upper
c    case keywords; CSTRING keywords are converted to upper case.
c    <value> is added to or subtracted from the current parameter
c    value if the = is replaced by a + or -.  If <value> ends in "t"
c    and an operation is designated, <value> is treated as a time in
c    the format, hh.mmssss.

	Character*(*) PARMS
c			Character string containing parameter information
c			in the format <VNAME>= <value> {/ <comment>} <linefeed>
c			Leading and trailing spaces are ignored.
	Character*(*) CSTRING
c			Character string containing command of the form
c			<keyword><=|+|-><value>[t]
c			*<keyword> cannot begin with a digit (0-9)
	Logical ASSIGNED
c			True if assignment is successful
	Logical LIST
c			True to print parameter value without name

	Logical VTEMP,PARSET,PARADD,ALPHA,PARLIST
	Character*1 NULL
c	Character*1 CSET
	Character*100 VALUE
	Character*20 VNAME
	Integer*4 IVAL,IVL,LV,L,IVNEW,IP,IVALUE,IT,IDAY,IL1,IL2,IER,LVAL,IC
	Integer*4 PVAL,NVAL,ICHR
	Real*8 DVALUE,DVNEW,TSEC,DTSEC

	Include 'header.cmb'

	NULL = Char (0)
	Call ZSTRING (VALUE)
	ASSIGNED = .false.

	VTEMP = VERBOSE
c	VERBOSE = .true.
	Call PADNULL (CSTRING)
	PARSET = .false.
	PARADD = .false.
	PARLIST = .false.

	If (CSTRING(1:1) .eq. '-') Return
	If (CSTRING(1:1) .eq. '@') Return
	If (CSTRING(1:1) .eq. '/') Return
	If (CSTRING(1:1) .eq. '.') Return

c  Return if first character is a number
	ICHR = Ichar (CSTRING(1:1))
	If ((ICHR .ge. 48) .and. (ICHR .lt. 58)) Return

c  Check for set, add, or subtract in argument string
	LV = Index (CSTRING,'=') - 1
	If (LV .gt. 0) Then
	    PARSET = .true.
c	    CSET = '='
	Else
	    PARSET = .false.
	    LV = Index (CSTRING,'+') - 1
	    If (LV .gt. 0) Then
		PARADD = .true.
c		CSET = '+'
	    Else
		LV = Index (CSTRING,'/')
		If (LV .gt. 0) Return
		LV = Index (CSTRING,'-') - 1
		If (LV .gt. 0) Then
c		    CSET = '-'
		Else
c		    If (VERBOSE) Then
c			Write (*,*) 'CGET: No operator in parameter assignment'
c			Endif
		    Call VLEN (CSTRING,LV)
		    PARLIST = .true.
		Endif
	    Endif
	Endif

c  Extract the variable name from the argument string and capitalize it
	VNAME = CSTRING(1:LV)
	Do 300 L = 1, LV
	    IVL = Ichar (VNAME(L:L))
	    If (IVL .gt. 96) Then
		IVL = IVL - 32
		VNAME(L:L) = Char (IVL)
		Endif
300	    Continue

	VNAME(LV+1:LV+1) = NULL
	Call PADNULL (VNAME)
	Call PSEARCH (PARMS,VNAME,PVAL,NVAL)

c  List current value only
	If (PARLIST) Then
	    VTEMP = VERBOSE
	    If (LIST) Then
		VALUE = '?'
		Call PADNULL (VALUE)
		Call PGETC (PARMS,VNAME,VALUE)
		Call VLEN (VALUE,LVAL)
		Call PCHRS (LVAL,VALUE)
	    Else
		VERBOSE = .true.
		VALUE = 'not assigned'
		Call PADNULL (VALUE)
		Call PGETC (PARMS,VNAME,VALUE)
		VERBOSE = VTEMP
	    Endif
	    LIST = .true.
	    ASSIGNED = .true.
	    Return
	Else
	    LIST = .false.
	Endif

c  Extract the value from the argument string
	IL1 = LV + 2
	Call VLEN (CSTRING,IL2)
	VALUE = CSTRING(IL1:IL2)
	Call PADNULL (VALUE)
	Call VLEN (VALUE,LVAL)

c	If (VERBOSE) Then
c	    Write(*,*) I,'/',NARG,PARMFILE(1:LP),VNAME(1:LV),CSET,VALUE(1:LVAL)
c	    Endif

c  Check to see if string is alphanumeric
	ALPHA = .false.
	Do 320 IVAL = 1, LVAL
	    If (Ichar (VALUE(IVAL:IVAL)) .gt. 64) ALPHA = .true.
320	    Continue

c  If value is to be set only, do it as character string
	If (PARSET) Then
	    Call HVERB (VERBOSE)
	    If (ALPHA) Then
		Do IVAL = 1, LVAL
		    If (VALUE(IVAL:IVAL) .eq. '_') VALUE(IVAL:IVAL) = ' '
		    Enddo
		Call PPUTS (PARMS,VNAME,VALUE)
	    Else
		Call PPUTC (PARMS,VNAME,VALUE)
	    Endif
	    ASSIGNED = .true.

c  Otherwise, extract current value from parameter string and operate on it
	Elseif (PVAL .gt. 0) Then

c  If value has no '.' in it, assume it to be an integer
	    IP = Index (VALUE(1:LVAL),'.')
	    IC = Index (VALUE(1:LVAL),':')
	    If ((IP .eq. 0) .and. (IC .eq. 0)) Then

c  Get current value of parameter and change to it
		Call PGETI4 (PARMS,VNAME,IVALUE)
		Call ASCBINI4 (LVAL,VALUE,IVNEW,IER)
		If (IER .ne. 0) Then
		    Write(*,350) VALUE(1:LVAL),IVNEW
350		    Format('CGET: Illegal value "',A,'"',I7)
		    ASSIGNED = .false.
		    Return
		    Endif

c  Add or subtract, then put the value back into the parameter string
		If (PARADD) Then
		    IVALUE = IVALUE + IVNEW
		Else
		    IVALUE = IVALUE - IVNEW
		Endif
		Call HVERB (VERBOSE)
		Call PPUTI4 (PARMS,VNAME,IVALUE)

c  If value has a '.', assume it to be floating point
	    Else
		Call PGETR8 (PARMS,VNAME,DVALUE)

c  If value ends in t, drop the t and treat it as a time (hh.mmssss)
		IT = Index (VALUE(1:LVAL),'t')
		If (IT .gt. 0) LVAL = IT - 1

		Call ASCBINR8 (LVAL,VALUE,DVNEW,IER)
		If (IER .ne. 0) Then
		    Write(*,355) VALUE(1:LVAL),DVNEW
355		    Format('CGET: Illegal value "',A,'"',F13.7)
		    ASSIGNED = .false.
		    Return
		    Endif

c  If value is a time, convert it to seconds before operating, then back to hh.mmsss
		If ((IC .gt. 0) .or. (IT .gt. 0)) Then
		    Call TCON (1,DVALUE,TSEC)
		    Call TCON (1,DVNEW,DTSEC)
		    If (PARADD) Then
			TSEC = TSEC + DTSEC
		    Else
			TSEC = TSEC - DTSEC
		    Endif
		    Call TCON1 (TSEC,IDAY,DVALUE)

c  If value isn't a time, just add it or subtract it
		Else
		    If (PARADD) Then
			DVALUE = DVALUE + DVNEW
		    Else
			DVALUE = DVALUE - DVNEW
		    Endif
		Endif

c  Put the value back into the parameter string
		Call PPUTR8 (PARMS,VNAME,DVALUE)

	    Endif
	    ASSIGNED = .true.
	Endif
	Return
	End

c May  8 1992	If no operator and not -<vname>, print value, ASSIGNED = false
c May 14 1992	If PARLIST and parameter not found, print nothing
c May 14 1992	Change value only if parameter is found
c Aug 21 1992	ASCBIN now returns IER=0 if OK instead of IER=1
c Oct 16 1992	Declare undeclared variables
c Oct 21 1992	Stop if only one value is being printed
c Oct 26 1992	Return without action if first character of keyword is number
c Oct 28 1992	Change name to PSET from CGET
c Oct 28 1992	Increase max string length to 100
c Nov 18 1992	Return without action if first character is @

c Feb 22 1993	Substitute single quotes for double quotes; drop unused parsub

c Jun 22 1995	Remove underscores used instead of spaces

c Aug 12 1996	Add as vigesimal if colon in number

c Jun  9 1998	Drop out if first character is / or .
