/*** File iolib/sfopen.c
 *** June 21, 1985
 *** By Dick French, modified by Doug Mink
 */

#include <sys/file.h>
#include </usr/include/stdio.h>

sfopen_ (idev,iflag,path,nc)

/*   Open UNIX file (Fortran-callable) for buffered I/O using system routines.
 *
 *	Call SFOPEN (IDEV,IFLAG,PATH)
 *
 *	Integer*4 IDEV
 *		Address of UNIX file descriptor (returned) (-1 if open failed)
 *	Integer*4 IFLAG
 *		Address of iflag :
 *		0	open for reading
 *		1	create for writing
 *		2	create for reading and writing at start of file
 *		3	append: open for writing at end of file, or create
 *			for writing
 *	Character*(*) PATH
 *			Address of null-terminated file name (=path name)
 *
 *	nc	Number of characters in string PATH
 *		* this is not explicitly in the calling argument list;
 *		* Fortran puts it there, necessitating this variation on SPUT
 */

char *path;
int *iflag;
int *idev;
int nc;

{
char *type;
FILE *stream;
int offset;

	if (*iflag == 0) type = "r";
	if (*iflag == 1) type = "w";
	if (*iflag == 2) type = "w+";
	if (*iflag == 3) type = "a";

	stream = fopen (path,type);

	if (stream == NULL)
		*idev = -1; /* set device to -1 if open failed*/
	else
		*idev = (int)stream;
	
	return;
}
