/*** File timstr.c
 *** March 24, 2008
 *** By Doug Mink
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <string.h>

/*   Return current local time as a string */

timstr_ (string)

char *string;	/* Day Month Year  Hour:Minutes:Seconds.Milliseconds */
{
    int year;
    time_t tsec;
    struct timeval tp;
    struct timezone tzp;
    struct tm *ts;
    char dmon[12][4];

/* Names of the months of the year */
    strcpy (dmon[0], "Jan");
    strcpy (dmon[1], "Feb");
    strcpy (dmon[2], "Mar");
    strcpy (dmon[3], "Apr");
    strcpy (dmon[4], "May");
    strcpy (dmon[5], "Jun");
    strcpy (dmon[6], "Jul");
    strcpy (dmon[7], "Aug");
    strcpy (dmon[8], "Sep");
    strcpy (dmon[9], "Oct");
    strcpy (dmon[10], "Nov");
    strcpy (dmon[11], "Dec");

    gettimeofday (&tp,&tzp);

    tsec = tp.tv_sec;
    ts = localtime (&tsec);

    if (ts->tm_sec > 30)
	ts->tm_min = ts->tm_min + 1;
    if (ts->tm_min > 59) {
	ts->tm_min = ts->tm_min - 60;
	ts->tm_hour = ts->tm_hour + 1;
	}
    if (ts->tm_hour > 23) {
	ts->tm_hour = ts->tm_hour - 24;
	ts->tm_mday = ts->tm_mday + 1;
	}
    if (ts->tm_year > 1000)
	year = ts->tm_year;
    else
	year = ts->tm_year + 1900;

    sprintf (string,"%d %s %d %02d:%02d",
	ts->tm_mday, dmon[ts->tm_mon], year, ts->tm_hour, ts->tm_min);
    return;
}
/*
 * Sep 13 1996	New subroutine
 * Nov 20 1996	Change order from mdy to dmy
 * Nov 26 1996	Fix year
 *
 * Mar 24 2008	Include stdio.h and stdlib.h for sprintf()
 */
