c*** File iolib/tokenize.f
c*** February 22, 1993
c*** By Doug Mink, Center for Astrophysics

c-- Subroutine to tokenize a string for easy decoding

	Subroutine TOKENIZE (STRING, NTMAX, ARTERM, NTOK, TOK0, TOK1)

	Character*(*) STRING
c				Character string to tokenize
	Integer*4 NTMAX
c				Maximum number of tokens
	Logical ARTERM
c				true to stop at -,+, else only whitespace
	Integer*4 NTOK
c				Number of tokens found (returned)
	Integer*4 TOK0(*)
c				Indices of first characters of tokens (returned)
	Integer*4 TOK1(*)
c				Indices of last characters of tokens (returned)

	Integer*4 I0,ITYPE,I,LSTR,ISP,JSP(10)

	Call VLEN (STRING, LSTR)
	I0 = 1
	NTOK = 0

100	JSP(1) = Index (STRING(I0:LSTR),' ')
	JSP(2) = Index (STRING(I0:LSTR),',')
	JSP(3) = Index (STRING(I0:LSTR),Char(9))
	If (ARTERM) Then
	    JSP(4) = Index (STRING(I0:LSTR),'-')
	    JSP(5) = Index (STRING(I0:LSTR),'+')
	Else
	    JSP(4) = 0
	    JSP(5) = 0
	Endif
	JSP(6) = LSTR + 1
	ISP = 100000
	Do 110 I = 1, 6
	    If ((JSP(I) .gt. 0) .and. (JSP(I) .lt. ISP)) Then
		ISP = JSP(I)
		ITYPE = I
		Endif
110	    Continue
	If (ISP .eq. 100000) ISP = 0

c  If terminator is a - or +, pass that as a separate token

	If ((ISP .gt. 1) .and. ((ITYPE .eq. 4) .or. (ITYPE .eq. 5))) Then
	    NTOK = NTOK + 1
	    If (NTOK .gt. NTMAX) Return
	    ISP = ISP - 1
	    TOK0(NTOK) = I0
	    TOK1(NTOK) = I0 + ISP - 1
	    NTOK = NTOK + 1
	    If (NTOK .gt. NTMAX) Return
	    TOK0(NTOK) = I0 + ISP
	    TOK1(NTOK) = I0 + ISP

c  If terminator is a space, comma, or tab, pass string it terminates

	Elseif (ISP .gt. 1) Then
	    NTOK = NTOK + 1
	    If (NTOK .gt. NTMAX) Return
	    ISP = ISP - 1
	    TOK0(NTOK) = I0
	    TOK1(NTOK) = I0 + ISP - 1
	Endif
	I0 = I0 + ISP

	If ((I0 .le. LSTR) .and. (ISP .gt. 0)) Then
	    Go to 100

	Elseif ((NTOK .gt. 0) .and. (TOK1(NTOK) .lt. LSTR)) Then
	    NTOK = NTOK + 1
	    If (NTOK .gt. NTMAX) Return
	    TOK0(NTOK) = I0
	    TOK1(NTOK) = LSTR
	Endif
	If (TOK1(NTOK) .gt. LSTR) TOK1(NTOK) = LSTR

	Return
	End

c Sep 26 1990	Add arithmetic terminator switch for interpreting ranges
c		Handle end of string correctly

c Feb 22 1993	Declare undeclared variables i and itype
